C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C     PROGRAM NLSWRUP.for
C     Non-Linear Shallow Water with Run UP
C     Input eta at boundary and track of Cyclone
C     search "Check" to check data set you need to specify
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
c      PARAMETER (MX=900,MY=900)
      COMMON /PARA0/KMAX,IS,IE,JS,JE
      COMMON /PARA1/DT,DX,DY
      COMMON /TDMIN/ TDMIN
      COMMON /TSTART/ TSTART
C
C
Check
      TDMIN=0.2
      TSTART=0.0
Check
C
C
C
C --- Input i100.05----------------------------------------------
      CALL CREAD
      WRITE(6,*)':::CREAD END:::'
C----------------------------------------------------------------
C --- input map--------------------------------------------------
      CALL MPREAD
      WRITE(6,*)':::MPREAD END:::'
C-----input depth data-------------------------------------------
      CALL DPREAD
      WRITE(6,*)':::DPREAD END:::'
C----------------------------------------------------------------
C --- input roughness--------------------------------------------
c       CALL RNREAD
c      WRITE(6,*)':::RNREAD END:::'
C----------------------------------------------------------------
C --- produce (or input) incident wave data----------------------
C      CALL DTREAD
C      WRITE(6,*)':::DTREAD END:::'
C
      CALL INHURR
      CALL IN_ETAB
C
C----------------------------------------------------------------
C ---- set sponge layer------------------------------------------
      CALL ERIC
      WRITE(6,*)':::ERIC END:::'
C----------------------------------------------------------------
C----------------------------------------------------------------
C --- NLSW Computation Start-------------------------------------
      WRITE(6,*)':::CAL START:::'
C
      CALL CAL
C
      WRITE(6,*)':::CAL END:::'
C
      STOP
      END
C
C:::::::::::::::::::::::::::::::::::::::
      SUBROUTINE CREAD
C:::::::::::::::::::::::::::::::::::::::
      PARAMETER (MX=900,MY=900)
      COMMON /PARA0/KMAX,IS,IE,JS,JE
      COMMON /PARA1/DT,DX,DY
      COMMON /WAVE0/E0,TERM,THETA
      COMMON /DEPTH/SH(MX,MY),SHX(MX,MY),SHY(MX,MY),TIDE
      COMMON /SLOPES/ DSHDX(MX,MY),DSHDY(MX,MY)
      COMMON /BREAK/ DSP(MX,MY),SLOP,JBRK
      COMMON /BOUSS/ BB,BB3
      COMMON /INCD0/ETDAT(0:150000),IREG
      COMMON /BLCK3/MAP(MX,MY)
      COMMON /SPNG/ ALP0,BET0
      COMMON /FRIC0/ FLOS,RN1(MX,MY),RN2(MX,MY)
      COMMON /nuk/ NOPEN
      COMMON /KYUSHU/ EPS(MX,MY),EPS2(MX,MY),IO,JO,R,ETHE
      COMMON /DLIMT/ LIMT,DLIM
      COMMON /DCHGK/ KDCHGS,KDCHGE
      COMMON /SMPL/ KSMPL
C
      OPEN(5,FILE='card.dat')
C
      READ(5,*)
      READ(5,*)DT,DX,DY
      THETA=0.0
C
      READ(5,*)
      READ(5,*)IREG
      write(6,*)'IREG=',IREG
C
      READ(5,*)
      READ(5,*)Hin,TERM,TIDE
      E0=0.5*Hin
C
      READ(5,*)
      READ(5,*)KMAX,IE,JE
      IS=1
      JS=1
      JBRK=1
C
      READ(5,*)
      READ(5,*)KDCHGS,KDCHGE
C
      READ(5,*)
      READ(5,*)KSMPL
C
      READ(5,*)
      READ(5,*)MQP
C
      SLOP=0.02
      NOPEN=1
      MOPEN=1
C
      IO=0
      JO=0
       R=3.0
      ETHE=0.1
C
C
      CLOSE(5)
C
      RETURN
      END
C:::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE DTREAD
C:::::::::::::::::::::::::::::::::::::::::::::::::::::
      PARAMETER (MX=900,MY=900)
      COMMON /PARA1/DT,DX,DY
      COMMON /BOUSS/ BB,BB3
      COMMON /PARA0/KMAX,IS,IE,JS,JE
      COMMON /INCD0/ETDAT(0:150000),IREG
      COMMON /INCD1/ETA(240,MY),ETU(240,MY),ETV(240,MY)
      COMMON /BLCK3/MAP(MX,MY)
      COMMON /FLUXI/P00(MX,MY),P0N(MX,MY)
      COMMON /FLUXJ/Q00(MX,MY),Q0N(MX,MY)
      COMMON /SURF0/S00(MX,MY),S0N(MX,MY)
      COMMON /DEPTH/SH(MX,MY),SHX(MX,MY),SHY(MX,MY),TIDE
      COMMON /KYUSHU/ EPS(MX,MY),EPS2(MX,MY),IO,JO,R,ETHE
      COMMON /WAVE0/E0,TERM,THETA
c
      PAI=3.141592
       GR=9.800
C
        SIGM=2.*PAI/TERM
CCC Periodic Linear Sinusoidal wave CCC
      IF(IREG.LE.0)THEN
CCCCCCCCCCCCCCCCCCCCCCCCCC ˋȄ
       DO 50 J=3,JE+2
        IF(SH(3,J).LE.0.1.OR.MAP(3,J).EQ.-9)THEN
          DO KK=1,KMAX
            ETA(KK,J)=0.0
            ETU(KK,J)=0.0
            ETV(KK,J)=0.0
          ENDDO
          GOTO 50
        END IF
C
        WLL=SQRT(GR*SH(3,J))*TERM
        RTP=3.0/8.0*TERM
C
       DO 60 KK=1,KMAX
        PHAS0=SIGM*DT*FLOAT(KK-1)
     #       -2.*PAI*DY*SIN(THETA)*FLOAT(J-1)/WLL
        MPH=INT(PHAS0/2./PAI)
        PHASE=PHAS0-FLOAT(MPH)*2.*PAI
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
c         ETA(KK,J)=E0*SIN(PHASE)
c         ETU(KK,J)=WLL/TERM*E0*SIN(PHASE
c     #            +DX/2.*COS(THETA)/WLL*2.0*PAI)*COS(THETA)
c         ETV(KK,J)=WLL/TERM*E0*SIN(PHASE
c     #            +DY/2.*SIN(THETA)/WLL*2.0*PAI)*SIN(THETA)
c-------for high tide-----
c         ETA(KK,J)=0.5*E0*(1.0-COS(PHASE))
c         ETU(KK,J)=0.5*WLL/TERM*E0*(1.0-COS(PHASE
c     #            +DX/2.*COS(THETA)/WLL*2.0*PAI))*COS(THETA)
c         ETV(KK,J)=0.5*WLL/TERM*E0*(1.0-COS(PHASE
c     #            +DY/2.*SIN(THETA)/WLL*2.0*PAI))*SIN(THETA)
C         write(6,'(3e12.5)')eta(kk,4),etu(kk,4),etv(kk,4)
         rt=real(KK)*DT
         IF(rt.LE.RTP) THEN
           ETA(KK,J)=E0*rt/RTP
         ELSEIF(rt.LE.TERM) THEN
           ETA(KK,J)=E0*(1.0-(rt-RTP)/(TERM-RTP))
         ELSE
           ETA(KK,J)=0.0
         ENDIF
           ETU(KK,J)=0.2*ETA(KK,J)*WLL/TERM*COS(THETA)
           ETV(KK,J)=0.2*ETA(KK,J)*WLL/TERM*SIN(THETA)
c           ETU(KK,J)=0.0
c           ETV(KK,J)=0.0
C
   60  CONTINUE
   50  CONTINUE
      ENDIF
C
      IF(IREG.EQ.2) THEN
      OPEN(51,FILE='e.dat')
      OPEN(61,FILE='p.dat')
      OPEN(71,FILE='q.dat')
      do 20 K=1,KMAX
          READ(51,*)(ETA(K,j),j=3,je+2)
          READ(61,*)(ETU(K,j),j=3,je+2)
          READ(71,*)(ETV(K,j),j=3,je+2)
   20 continue
      CLOSE(51)
      CLOSE(61)
      CLOSE(71)
      END IF
c
c
      IF(IREG.EQ.3) THEN
      open(87,file='ein.dat')
      read(87,*) DTT, NTT
       do nt=1,NTT
          READ(87,*)ETDAT(nt)
       enddo
      CLOSE(87)
      nt=1
      ttt=DTT
      tt0=0.0
      ETDAT(0)=0.0
      do k=1,kmax
        tm=dt*real(k)
   22 continue
        if(tm.le.ttt) then
          do j=3,je+2
             eta(k,j)=ETDAT(nt-1)+(ETDAT(nt)-ETDAT(nt-1))
     #               *(tm-tt0)/(ttt-tt0)
          enddo
        else
          nt=nt+1
          tt0=ttt
          ttt=ttt+dtt
          if(nt.ge.NTT+1) then
           nt=1
          endif
          goto 22
        endif
      enddo
      ENDIF
C
C
C===== Hakei taper======================
c       jtp=10
c       do j=3,jtp+2
c          rrr=0.5*(1.0-cos(3.14159265*real(j-3)/real(jtp)))
c          do k=1,kmax
c            eta(k,j)=eta(k,j)*rrr
c            etu(k,j)=etu(k,j)*rrr
c            etv(k,j)=etv(k,j)*rrr
c          end do
c       end do
cc
c       do j=je+3-jo,je+2
c          rrr=0.5*(1.0-cos(3.14159265*real(je+2-j)/real(jo)))
c          do k=1,kmax
c            eta(k,j)=eta(k,j)*rrr
c            etu(k,j)=etu(k,j)*rrr
c            etv(k,j)=etv(k,j)*rrr
c          end do
c       end do
C
      RETURN
      END
C
C
C:::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE REGSET
C:::::::::::::::::::::::::::::::::::::::::::::::::::
      PARAMETER (MX=900,MY=900)
      COMMON /PARA0/KMAX,IS,IE,JS,JE
      COMMON /DEPTH/SH(MX,MY),SHX(MX,MY),SHY(MX,MY),TIDE
      COMMON /CREG0/MRG(MY),NRG(MX),ITS(MY,150),ITE(MY,150),
     &                              JTS(MX,150),JTE(MX,150)
      COMMON /TDP/ TD(MX,MY),TDX(MX,MY),TDY(MX,MY)
      COMMON /TDMIN/ TDMIN
      COMMON /DSWC/ SDX(MX,MY),SDY(MX,MY)
C
      DO 10 J=3,JE+2
      IC=0
      IF(TDX(3,J).GT.TDMIN)THEN
       IC=IC+1
       ITS(I,IC)=3
      ENDIF
      DO 15 I=3,IE+1
      IF(SDX(I,J).LE.TDMIN.AND.SDX(I+1,J).GT.TDMIN)THEN
       IC=IC+1
       ITS(J,IC)=I
      ENDIF
      IF(SDX(I,J).GT.TDMIN.AND.SDX(I+1,J).LE.TDMIN)THEN
       ITE(J,IC)=I+1
      ENDIF
   15 CONTINUE
      IF(SDX(IE+2,J).GT.TDMIN)THEN
       ITE(J,IC)=IE+3
      ENDIF
      MRG(J)=IC
C
   10 CONTINUE
C
      DO 20 I=3,IE+2
      IC=0
      IF(TDY(I,3).GT.TDMIN)THEN
       IC=IC+1
       JTS(I,IC)=3
      ENDIF
      DO 25 J=3,JE+1
      IF(SDY(I,J).LE.TDMIN.AND.SDY(I,J+1).GT.TDMIN)THEN
       IC=IC+1
       JTS(I,IC)=J
      ENDIF
      IF(SDY(I,J).GT.TDMIN.AND.SDY(I,J+1).LE.TDMIN)THEN
       JTE(I,IC)=J+1
      ENDIF
   25 CONTINUE
      IF(SDY(I,JE+2).GT.TDMIN)THEN
       JTE(I,IC)=JE+3
      ENDIF
      NRG(I)=IC
   20 CONTINUE
C
c         do ic=1,nrg(49)
c            write(6,*)'i=49','IC=',ic,jts(49,ic)-3,jte(49,ic)-3
c         enddo
c         do ic=1,mrg(69)
c            write(6,*)'j=69','IC=',ic,its(69,ic)-3,ite(69,ic)-3
c         enddo
C
      RETURN
      END
C:::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE CAL
C:::::::::::::::::::::::::::::::::::::::::::::::::::::
      PARAMETER (MX=900,MY=900)
      COMMON /PARA0/KMAX,IS,IE,JS,JE
      COMMON /PARA1/DT,DX,DY
      COMMON /SPARA/ D50,wf,taucr,rmuk,NSED,tanfs,tanfm,dts,za
      COMMON /RHOS/ RHO,RHOS,S
      COMMON /WAVE0/E0,TERM,THETA
      COMMON /BREAK/ DSP(MX,MY),SLOP,JBRK
      COMMON /DEPTH/SH(MX,MY),SHX(MX,MY),SHY(MX,MY),TIDE
      COMMON /SURF0/S00(MX,MY),S0N(MX,MY)
      COMMON /FLUXI/P00(MX,MY),P0N(MX,MY)
      COMMON /FLUXJ/Q00(MX,MY),Q0N(MX,MY)
      COMMON /VELO0/BOTV(MX,MY),UU(MX,MY),VV(MX,MY)
      COMMON /INCD0/ETDAT(0:150000),IREG
      COMMON /nuk/ NOPEN
      COMMON /KYUSHU/ EPS(MX,MY),EPS2(MX,MY),IO,JO,R,ETHE
      COMMON /BLCK3/MAP(MX,MY)
      COMMON /SPNG/ ALP0,BET0
      COMMON /F1G1/ FF(MX,MY),GG(MX,MY)
      COMMON /TDP/ TD(MX,MY),TDX(MX,MY),TDY(MX,MY)
      COMMON /TDMIN/ TDMIN
      COMMON /HAKO/ HH(MX,MY),EMIN(MX,MY)
      COMMON /GEOG/ BL(MX,MY)
      COMMON /CONC/ CN(MX,MY),C0(MX,MY)
      COMMON /RNESS/ RKS(MX,MY)
      COMMON /GEO2/ DP0(MX,MY),DP1(MX,MY)
      COMMON /CONV/ CVX(MX,MY),CVY(MX,MY)
      COMMON /DCHG/ DCHG(MX,MY)
      COMMON /DCHGK/ KDCHGS,KDCHGE
      COMMON /SMPL/ KSMPL
      COMMON /SHEAR/ TSX(MX,MY),TSY(MX,MY)
      COMMON /PRSUR/ PSR(MX,MY),DPDX(MX,MY),DPDY(MX,MY)
      COMMON /CREG0/MRG(MY),NRG(MX),ITS(MY,150),ITE(MY,150),
     &                              JTS(MX,150),JTE(MX,150)
      COMMON /taper/ taper
      COMMON /DSWC/ SDX(MX,MY),SDY(MX,MY)
c      COMMON /HURR/itend,tdt,tt(100),tx(100),ty(100),tp0(100),tr0(100)
      COMMON /WIND/ WX(MX,MY),WY(MX,MY)
c      COMMON /TAUS0/itend,tmin(200),tsx0(200),tsy0(200)
      COMMON /HURR/itend,tdt,tt(100),tx(100),ty(100),tp0(100),tr0(100)
      COMMON /ETA0/ JEMON,DYEMON,iteta, etab0(500,MY),tmin(500)
      COMMON /TSTART/ TSTART
      COMMON /posit/ xxx(mx,my),yyy(mx,my)
      dimension wabs(mx,my)
C
      character f95*17
C
cvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
      dimension uvel(mx,my),vvel(mx,my),vabs(mx,my)
      dimension emon(60,mx,my),dsat(mx,my)
cvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
      DIMENSION ETAMAX(MX,MY),ETAMIN(MX,MY)
      DIMENSION t00(MX,MY),t01(MX,MY),t02(MX,MY)
     &         ,t03(MX,MY),t04(MX,MY),t05(MX,MY)
     &         ,dmax(MX,MY),Xmax(mx,my)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C++++++++++++++++++++++++++++++++++++++++++
      do i=1,ie+4
      do j=1,je+4
       IF(MAP(I,J).EQ.0) THEN
        S00(I,J)    =MAX(0.0,BL(I,J))
        S0N(I,J)    =MAX(0.0,BL(I,J))
       ELSE
        S00(I,J)    =BL(I,J)
        S0N(I,J)    =BL(I,J)
       ENDIF
C
      dsat(i,j)    =0.0
      vabs(i,j)    =0.0
       P00(I,J)    =0.0
       P0N(I,J)    =0.0
       Q00(I,J)    =0.0
       Q0N(I,J)    =0.0
        FF(I,J)    =0.0
        GG(I,J)    =0.0
       uvel(i,j)   =0.0
       vvel(i,j)   =0.0
       ETAMAX(i,j) =0.0
       ETAMIN(i,j) =0.0
       DSP(I,J)    =0.0
         HH(I,J)   =0.0
       EMIN(I,J)   =0.0
         TD(I,J)   =TDMIN
        TDX(I,J)   =TDMIN
        TDY(I,J)   =TDMIN
        SDX(I,J)   =TDMIN
        SDY(I,J)   =TDMIN
        RKS(I,J)   =D50
       DCHG(I,J)   =0.0
        TSX(I,J)   =0.0
        TSY(I,J)   =0.0
       DPDX(I,J)   =0.0
       DPDY(I,J)   =0.0
c
         t00(I,J)  =99999.0
         t01(I,J)  =99999.0
         t02(I,J)  =99999.0
         t03(I,J)  =99999.0
         t04(I,J)  =99999.0
         t05(I,J)  =99999.0
        dmax(I,J)  =0.0
        Xmax(i,j)  =0.0
c
         do moni=1,60
            emon(moni,i,j)=0.0
         enddo
      end do
      end do
C
       call position
C
C########################################################################
C########### ==TIME-LOOP START== ########################################
C########################################################################
C
      ndata=0
C
      CALL DSPCAL
      CALL FRICT2
C
c      KMAX=INT(REAL(itend-1)*tdt/DT*60.0)
      KMAX=INT((tmin(iteta)-TSTART)*60.0/DT)+1
C
cc      open(72,file='Hmonout.dat')
c      open(73,file='emonout.dat')
cc      open(74,file='emonout200.dat')
cc      open(75,file='emonout500.dat')
c
C
      write(6,*)'KMAX=',KMAX
C
      DO 100 KK=1,KMAX
C
      treal=TSTART+DT*REAL(KK-1)/60.0
      if(treal.le.120.0) then
        taper=0.5*(1.0-cos(3.14159265*treal/120.0))
      else
        taper=1.0
      endif
C
      if(mod(KK,100).eq.1) then
Check    fujita's model
c         call windpress(treal) 
Check    SGW with Myers
         call windSGW(treal)
C
c         call shearcal(treal)
         call ebcal(treal)
         write(6,*) 'Step=',kk-1,'/',KMAX,'  t(min)=',treal, taper
      endif
C
C      goto 172
C
      if(KK.GE.KDCHGS.AND.KK.LE.KDCHGE) THEN
         DO I=3,IE+2
         DO J=3,JE+2
            BLN=-TIDE+DP0(I,J)+(DP1(I,J)-DP0(I,J))
     #             *REAL(KK-KDCHGS)/REAL(KDCHGE-KDCHGS)
            DCHG(I,J)=BLN-BL(I,J)
              BL(I,J)=BLN
C
                CVX(I,J)=1.0
            IF(ABS(BL(I,J)-BL(I-1,J)).GE.0.2*dx) THEN
                CVX(I,J)=0.0
            ENDIF
C
                CVY(I,J)=1.0
            IF(ABS(BL(I,J)-BL(I,J-1)).GE.0.2*dy) THEN
                CVY(I,J)=0.0
            ENDIF
C
            IF(I.EQ.3.or.I.EQ.IE+3.or.J.EQ.3.or.J.EQ.JE+3) THEN
                CVX(I,J)=0.0
                CVY(I,J)=0.0
            ENDIF
C
         END DO
         END DO
      else if(KK.EQ.KDCHGE+1) then
         DO I=3,IE+2
         DO J=3,JE+2
            DCHG(I,J)=0.0
         END DO
         END DO
      end if
C
C=====friction factor cal==========
C      if(mod(kk,10).eq.1) then
C         CALL FRICTION
C          CALL FRICT2
C      endif
C
C########################################################################
C#########################  X-DIRECTION  ################################
C########################################################################
C=====TOTAL DEPTH=======
      CALL TDEPX
      CALL REGSET
C=====momentum equation in x-direction=======
      DO 10 J=3,JE+2
      IF(MRG(J).EQ.0)GO TO 10
      DO 11 M=1,MRG(J)
c        write(6,*)'J, ITS and ITE=',J, ITS(J,M),ITE(J,M)
        CALL STEPX(J,ITS(J,M),ITE(J,M))
   11 CONTINUE
   10 CONTINUE
      DO I=2,IE+3
         P0N(I,2)=P0N(I,3)
         P0N(I,JE+3)=P0N(I,JE+2)
      ENDDO
C===== renew ==========================
      DO I=1,IE+4
      DO J=1,JE+4
         P00(I,J)=P0N(I,J)
      ENDDO
      ENDDO
C=====mass conservation equation=======
      CALL CONSV
C      WRITE(6,*)':::CONTP:::'
C===== renew ==========================
      DO I=1,IE+4
      DO J=1,JE+4
         S00(I,J)=S0N(I,J)
         P0N(I,J)=0.0
      ENDDO
      ENDDO
C########################################################################
C#########################  Y-DIRECTION  ################################
C########################################################################
C=====TOTAL DEPTH=======
      CALL TDEPY
      CALL REGSET
C=====momentum equation in x-direction=======
      DO 20 I=3,IE+2
      IF(NRG(I).EQ.0)GO TO 20
      DO 21 N=1,NRG(I)
        CALL STEPY(I,JTS(I,N),JTE(I,N))
   21 CONTINUE
   20 CONTINUE
      DO J=2,JE+3
         Q0N(2,J)=Q0N(3,J)
         Q0N(IE+3,J)=Q0N(IE+2,J)
      ENDDO
C===== renew ==========================
      DO I=1,IE+4
      DO J=1,JE+4
         Q00(I,J)=Q0N(I,J)
      ENDDO
      ENDDO
C=====mass conservation equation=======
      CALL CONSV
C      WRITE(6,*)':::CONTP:::'
C===== renew ==========================
      DO I=1,IE+4
      DO J=1,JE+4
         S00(I,J)=S0N(I,J)
         Q0N(I,J)=0.0
C
C
         if(i.ge.2.and.i.le.ie+2) then
         if(j.ge.2.and.j.le.je+2) then
         if(map(I,J).eq.0) THEN
           ddd=0.0
         else
           ddd=S0N(I,J)-BL(I,J)
         endif
c         if(BL(I,J).GE.-2.0) THEN
c           ddd=S0N(I,J)-BL(I,J)
c         else
c           ddd=0.0
c         endif
c
         if(dmax(i,j).le.ddd) dmax(i,j)=ddd
         if(t00(i,j).gt.99990.and.ddd.gt.0.2)t00(i,j)=treal
         if(t01(i,j).gt.99990.and.ddd.gt.0.5)t01(i,j)=treal
         if(t02(i,j).gt.99990.and.ddd.gt.0.7)t02(i,j)=treal
         if(t03(i,j).gt.99990.and.ddd.gt.1.0)t03(i,j)=treal
         if(t04(i,j).gt.99990.and.ddd.gt.2.0)t04(i,j)=treal
         if(t05(i,j).gt.99990.and.ddd.gt.3.0)t05(i,j)=treal
         endif
         endif
C
         XX0=((P00(I,J)+P00(I+1,J))**2
     &             +(Q00(I,J)+Q00(I,J+1))**2)/TD(I,J)/4.0
         if(XX0.gt.Xmax(i,j)) Xmax(i,j)=XX0
C
C
      ENDDO
      ENDDO
C
C======= OUTPUT ============================================
C  172 continue
      IF(MOD(KK,KSMPL).eq.0) then
c      write(f95(1:17),'(A17)')'output\out000.csv'
      write(f95(1:17),'(A17)')'output\out000.dat'
      ndata=ndata+1
      if(ndata.le.9) then
        write(f95(13:13),'(i1)')ndata
      elseif(ndata.le.99) then
        write(f95(12:13),'(i2)')ndata
      else
        write(f95(11:13),'(i3)')ndata
      endif
C
      DO I=3,IE+2
      DO J=3,JE+2
C
      dchk=1.1*TDMIN
C
       if(tdx(i,j).gt.dchk.and.tdx(i+1,j).gt.dchk) then
        if(i.le.ie+1) then
        uvel(i,j) = 0.5*(P00(I,J)/TDX(I,J)+P00(I+1,J)/TDX(I+1,J))
        else
        uvel(i,j) = P00(I,J)/TDX(I,J)
        endif
       else
        uvel(i,j)=0.0
       endif
       if(tdy(i,j).gt.dchk.and.tdx(i,j+1).gt.dchk) then
        vvel(i,j) = 0.5*(Q00(I,J)/TDY(I,J)+Q00(I,J+1)/TDY(I,J+1))
       else
        vvel(i,j)=0.0
       endif
       if(abs(uvel(i,j)).gt.1.0e-10.or.abs(vvel(i,j)).gt.1.0e-10) then
        vabs(i,j)=sqrt(uvel(i,j)**2+vvel(i,j)**2)
       else
        vabs(i,j)=0.0
       endif
C
       dsat(i,j)=max(0.0,S0N(I,J)-BL(I,J))
C
c          if(S0N(I,J).LE.BL(I,J)+TDMIN.or.map(i,j).eq.2) then
c            S0G(I,J)=-999.0
c          else
c            S0G(I,J)=S0N(I,J)
c          endif
C
      END DO
      END DO
C
      open(95,file=f95)
C
c      write(95,*)'x',',','y',',','eta',',','u',',','v',',','dep'
c      do j=3,je+2
c      do i=ie+2,3,-1
c         write(95,'(f8.1,a1,f8.1,a1,f6.2,a1,f6.2,a1,f6.2,a1,f6.2)')
c     #   xxx(i,j),',',yyy(i,j),',',S0N(I,J)+tide,',',
c     #  vvel(i,j),',',-uvel(i,j),',',dsat(i,j)
c      enddo
c      enddo
      do i=3,ie+2
         write(95,'(2000f10.2)')(S0N(i,j),j=3,je+2)
      enddo
C
c
C
      ENDIF
      close(95)
C
C
cc      IF(MOD(KK,120).eq.0) then
cc         write(73,'(f8.1,301e15.5)')treal,(S0N(680,J),J=200,500)
cc         write(74,'(f8.1,231e15.5)')treal,(S0N(I,200),I=450,680)
cc         write(75,'(f8.1,231e15.5)')treal,(S0N(I,500),I=450,680)
cc      ENDIF
C
C
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC ETAMAX
      IF(mod(KK,10).eq.0) then
      DO I=IS+2,IE+2
      DO J=JS+2,JE+2
        IF(S0N(I,J).GT.ETAMAX(I,J).and.
     #     S0N(I,J).GT.-SH(I,J)*1.0001) THEN
          ETAMAX(I,J)=S0N(I,J)
        ENDIF
        IF(S0N(I,J).LT.ETAMIN(I,J)) THEN
          ETAMIN(I,J)=S0N(I,J)
        ENDIF
      END DO
      END DO
      END IF
C
C
c      if(mod(KK,50).eq.0.or.istop.eq.1) then
      if(mod(KK,500).eq.0) then
      open(22,file='tempE.dat')
c      open(23,file='tempP.dat')
c      open(24,file='tempQ.dat')
      do i=3,ie+2
c         do j=3,je+2
c        if(S0N(I,J).LE.BL(I,J)+TDMIN.or.map(i,j).eq.2) then
c            s0g(i,j)=BL(I,J)
c         else
c            s0g(i,j)=s0n(i,j)
c         endif
c         end do
         write(22,'(1700e11.3)') (S0N(i,j),j=3,je+2)
c         write(23,'(1000e11.3)') (TSX(i,j),j=3,je+2)
c         write(24,'(1000e11.3)') (TSY(i,j),j=3,je+2)
      end do
      close(22)
c      close(23)
c      close(24)
c
c      if(istop.eq.1) stop
c
      endif
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCNEXT DATA SET
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C
c      if(mod(kk,1200).eq.1) then
c        do moni=60,2,-1
c           do i=3,ie+2
c           do j=3,je+2
c              emon(moni,i,j)=emon(moni-1,i,j)
c           end do
c           end do
c        end do
c        do i=3,ie+2
c        do j=3,je+2
c           emon(1,i,j)=S0N(i,j)
c           if(S0N(I,J).LE.BL(I,J)+TDMIN.OR.MAP(I,J).EQ.2) then
c              emon(moni,i,j)=BL(I,J)
c           end if
c        end do
c        end do
c      endif
C
  100 CONTINUE
C
CCCCCCCCCCCCCCCCCCCCC
C
      OPEN(30,FILE='output\time.csv')
      OPEN(36,FILE='output\dmax.csv')
      OPEN(37,FILE='output\Xmax.csv')
C
      write(30,*)'x',',','y',',','t00',',','t01',',','t02',',','t03'
     #                      ,',','t04',',','t05'
      write(36,*)'x',',','y',',','dmax'
      write(37,*)'x',',','y',',','Xmax'
      do j=3,je+2
      do i=ie+2,3,-1
         if(map(i,j).ge.1) then
         write(30,'(f10.1,a1,f10.1,a1,f10.1,a1,f10.1,a1,f10.1,
     #                           a1,f10.1,a1,f10.1,a1,f10.1)')
     #         xxx(i,j),',',yyy(i,j)
     #         ,',',t00(I,J),',',t01(I,J),',',t02(I,J)
     #         ,',',t03(I,J),',',t04(I,J),',',t05(I,J)
         write(36,'(f8.1,a1,f8.1,a1,f6.1)')
     #         xxx(i,j),',',yyy(i,j),',',dmax(i,j)
         write(37,'(f8.1,a1,f8.1,a1,f6.1)')
     #         xxx(i,j),',',yyy(i,j),',',Xmax(i,j)
         endif
      enddo
      enddo
c
      close(30)
      close(36)
      close(37)
C
C
C
C
      RETURN
      END
C
C:::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE TDEPX
C:::::::::::::::::::::::::::::::::::::::::::::
      PARAMETER (MX=900,MY=900)
      COMMON /PARA0/KMAX,IS,IE,JS,JE
      COMMON /BLCK3/MAP(MX,MY)
      COMMON /DEPTH/SH(MX,MY),SHX(MX,MY),SHY(MX,MY),TIDE
      COMMON /TDP/ TD(MX,MY),TDX(MX,MY),TDY(MX,MY)
      COMMON /SURF0/S00(MX,MY),S0N(MX,MY)
      COMMON /TDMIN/ TDMIN
      COMMON /GEOG/ BL(MX,MY)
      COMMON /DSWC/ SDX(MX,MY),SDY(MX,MY)
      COMMON /CONV/ CVX(MX,MY),CVY(MX,MY)
C
      DO J=2,JE+3
       DO I=2,IE+3
        TD(I,J)=MAX(TDMIN*0.999,-BL(I,J)+S0N(I,J))
C        IF(MAP(I,J).EQ.-9) TD(I,J)=TDMIN*0.999
        IF(MAP(I,J).EQ.2) TD(I,J)=TDMIN*0.999
       END DO
        TD(2   ,J)=TD(3   ,J)
        TD(IE+3,J)=TD(IE+2,J)
      END DO
C
      DO I=3,IE+2
        TD(I,2   )=TD(I,3   )
        TD(I,JE+3)=TD(I,JE+2)
      END DO
C
      DO I=3,IE+3
      DO J=3,JE+3
C
c         IF((TD(I,J)-TDMIN)*(TD(I-1,J)-TDMIN).GT.0.0) THEN
c            TDX(I,J)=0.5*(TD(I,J)+TD(I-1,J))
         IF(MAP(I,J).EQ.2.OR.MAP(I-1,J).EQ.2) THEN
            TDX(I,J)=TDMIN*0.999
c         ELSEIF(CVX(I,J).GE.0.5) THEN
         ELSE
            TDX(I,J)=0.5*(TD(I,J)+TD(I-1,J))
c         ELSE
c            TDX(I,J)=MAX(S0N(I,J),S0N(I-1,J))-MAX(BL(I,J),BL(I-1,J))
         ENDIF
            SDX(I,J)=MAX(S0N(I,J),S0N(I-1,J))-MAX(BL(I,J),BL(I-1,J))
C
         TDX(I,J)=MAX(TDX(I,J),TDMIN*0.999)
         SDX(I,J)=MAX(SDX(I,J),TDMIN*0.999)
C
      END DO
        TDX(I,2)=TDX(I,3)
        SDX(I,2)=SDX(I,3)
      END DO
C
      DO J=3,JE+2
         TDX(2,J)=TDX(3,J)
         SDX(2,J)=SDX(3,J)
         TDX(IE+3,J)=TDX(IE+2,J)
         SDX(IE+3,J)=SDX(IE+2,J)
      END DO
C
C
      RETURN
      END
C
C
C:::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE TDEPY
C:::::::::::::::::::::::::::::::::::::::::::::
      PARAMETER (MX=900,MY=900)
      COMMON /PARA0/KMAX,IS,IE,JS,JE
      COMMON /BLCK3/MAP(MX,MY)
      COMMON /DEPTH/SH(MX,MY),SHX(MX,MY),SHY(MX,MY),TIDE
      COMMON /TDP/ TD(MX,MY),TDX(MX,MY),TDY(MX,MY)
      COMMON /SURF0/S00(MX,MY),S0N(MX,MY)
      COMMON /TDMIN/ TDMIN
      COMMON /GEOG/ BL(MX,MY)
      COMMON /DSWC/ SDX(MX,MY),SDY(MX,MY)
      COMMON /CONV/ CVX(MX,MY),CVY(MX,MY)
C
      DO J=2,JE+3
       DO I=2,IE+3
        TD(I,J)=MAX(TDMIN*0.999,-BL(I,J)+S0N(I,J))
C        IF(MAP(I,J).EQ.-9) TD(I,J)=TDMIN*0.999
        IF(MAP(I,J).EQ.2) TD(I,J)=TDMIN*0.999
       END DO
        TD(2   ,J)=TD(3   ,J)
        TD(IE+3,J)=TD(IE+2,J)
      END DO
C
      DO I=3,IE+2
        TD(I,2   )=TD(I,3   )
        TD(I,JE+3)=TD(I,JE+2)
      END DO
C
      DO I=3,IE+3
      DO J=3,JE+3
C
         IF(MAP(I,J).EQ.2.OR.MAP(I,J-1).EQ.2) THEN
            TDY(I,J)=TDMIN*0.999
c         ELSEIF(CVY(I,J).GE.0.5) THEN
         ELSE
            TDY(I,J)=0.5*(TD(I,J)+TD(I,J-1))
c         ELSE
c            TDY(I,J)=MAX(S0N(I,J),S0N(I,J-1))-MAX(BL(I,J),BL(I,J-1))
         ENDIF
            SDY(I,J)=MAX(S0N(I,J),S0N(I,J-1))-MAX(BL(I,J),BL(I,J-1))
C
         TDY(I,J)=MAX(TDY(I,J),TDMIN*0.999)
         SDY(I,J)=MAX(SDY(I,J),TDMIN*0.999)
C
      END DO
        TDY(I,2)=TDY(I,3)
        SDY(I,2)=SDY(I,3)
        TDY(I,JE+3)=TDY(I,JE+2)
        SDY(I,JE+3)=SDY(I,JE+2)
      END DO
C
      DO J=3,JE+2
         TDY(2,J)=TDY(3,J)
         SDY(2,J)=SDY(3,J)
      END DO
C
C
      RETURN
      END
C
C
C:::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE CONSV
C     continuity equation for predictor step
C:::::::::::::::::::::::::::::::::::::::::::::
      PARAMETER (MX=900,MY=900)
      COMMON /PARA0/KMAX,IS,IE,JS,JE
      COMMON /PARA1/DT,DX,DY
      COMMON /BLCK3/MAP(MX,MY)
      COMMON /FLUXI/P00(MX,MY),P0N(MX,MY)
      COMMON /FLUXJ/Q00(MX,MY),Q0N(MX,MY)
      COMMON /SURF0/S00(MX,MY),S0N(MX,MY)
      COMMON /DEPTH/SH(MX,MY),SHX(MX,MY),SHY(MX,MY),TIDE
      COMMON /GEOG/ BL(MX,MY)
      COMMON /TDMIN/ TDMIN
      COMMON /INCD1/ETA(240,MY),ETU(240,MY),ETV(240,MY)
      COMMON /DCHG/ DCHG(MX,MY)
      COMMON /DPQ/ DPP(MX,MY),DQQ(MX,MY)
      COMMON /ETAB/ ETAB(MY)
      COMMON /DSWC/ SDX(MX,MY),SDY(MX,MY)
C
      DO 10 J=3,JE+2
       DO 20 I=3,IE+2
C
c         if(sdx(i,j).gt.tdmin.or.sdx(i+1,j).gt.tdmin) then
          DPP(I,J)=(P00(I+1,J)-P00(I,J))/DX
c         else
c          DPP(I,J)=0.0
c         endif
c         if(sdy(i,j).gt.tdmin.or.sdy(i,j+1).gt.tdmin) then
          DQQ(I,J)=(Q00(I,J+1)-Q00(I,J))/DY
c         else
c          DQQ(I,J)=0.0
c         endif
C
         IF(map(i,j).ne.2) THEN
c            if(i.eq.3.or.i.eq.ie+2) then
            if(i.eq.ie+2) then
               S0N(I,J)=max(ETAB(j),BL(I,J))
c            elseif(j.eq.3.or.j.eq.je+2) then
c               S0N(I,J)=ETAB(j)
            else
               S0N(I,J)=S00(I,J)
     #                 -0.5*DT*(DPP(I,J)+DQQ(I,J))
     #                 +0.5*DCHG(I,J)
            endif
C
         S0N(I,J)=MAX(S0N(I,J),BL(I,J))
C
        ENDIF
   20 CONTINUE
         S0N(2   ,J)=S0N(3   ,J)
         S0N(IE+3,J)=S0N(IE+2,J)
   10 CONTINUE
C
      DO I=2,IE+3
         S0N(I,2   )=S0N(I,3   )
         S0N(I,JE+3)=S0N(I,JE+2)
      END DO
C
c      write(6,*)s00(48,68),s0n(48,68),dpp(48,68),dqq(48,68),dchg(48,68)
C
      RETURN
      END
C
C:::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE STEPX(J,IST,IED)
c---- corrector step for P----
C:::::::::::::::::::::::::::::::::::::::::::::
      PARAMETER (MX=900,MY=900)
      COMMON /PARA0/KMAX,IS,IE,JS,JE
      COMMON /PARA1/DT,DX,DY
      COMMON /WAVE0/E0,TERM,THETA
      COMMON /FLUXI/P00(MX,MY),P0N(MX,MY)
      COMMON /FLUXJ/Q00(MX,MY),Q0N(MX,MY)
      COMMON /SURF0/S00(MX,MY),S0N(MX,MY)
      COMMON /DEPTH/SH(MX,MY),SHX(MX,MY),SHY(MX,MY),TIDE
      COMMON /SLOPES/ DSHDX(MX,MY),DSHDY(MX,MY)
      COMMON /BOUSS/ BB,BB3
      COMMON /BREAK/ DSP(MX,MY),SLOP,JBRK
      COMMON /BACKF/ IBKF
      COMMON /INCD0/ETDAT(0:150000),IREG
      COMMON /FRIC0/ FLOS,RN1(MX,MY),RN2(MX,MY)
      COMMON /FRICT/ FRIC(MX,MY),FRICX(MX,MY),FRICY(MX,MY)
      COMMON /SCHM/ ISCHM
      COMMON /EPPA/ OV(MX,MY),OVA(MX,MY),HC,EP(MX),EPA(MX)
      COMMON /KYUSHU/ EPS(MX,MY),EPS2(MX,MY),IO,JO,R,ETHE
      COMMON /FG/ FF(MX,MY),GG(MX,MY)
      COMMON /PPQQ/ PP0(MX,MY),QQ0(MX,MY)
      COMMON /TDP/ TD(MX,MY),TDX(MX,MY),TDY(MX,MY)
      COMMON /BSQD/ BHX(MX,MY),BHY(MX,MY)
      COMMON /CONV/ CVX(MX,MY),CVY(MX,MY)
      COMMON /SHEAR/ TSX(MX,MY),TSY(MX,MY)
      COMMON /PRSUR/ PSR(MX,MY),DPDX(MX,MY),DPDY(MX,MY)
      COMMON /taper/ taper
      COMMON /DPQ/ DPP(MX,MY),DQQ(MX,MY)
C
      DIMENSION AR(MX),BR(MX),RN(MX,MY)
C
      GR=9.8
      BB=1.0/21.0
c      IF(TERM.GE.20.0) THEN
        bu=0.0
c      ELSE
C        bu=1.0
c      ENDIF
C
      DO 14 L=2,IE+3
      AR(L)=0.0
      BR(L)=0.0
   14 CONTINUE
C###################################################################
C#####BOUNDARY CONDITION @I=IST#####################################
c      IF(IST.GT.3) THEN
         P0N(IST,J)=0.0
c      ENDIF
C##### BOUNDARY CONDITION @I=IED #######################################
       IF(IED.EQ.IE+3) THEN
c          P0N(IED,J)=S0N(IED-1,J)*sqrt(9.8*SH(IED-1,J))
          P0N(IED,J)=P00(IED-1,J)
c          P0N(IED,J)=0.0
c          P00(IED,J)=0.0
       ELSE
             P0N(IED,J)=0.0
             P00(IED,J)=0.0
       ENDIF
C
C*********************@CALCULATION START *****************************
      DO 20 I=IST+1,IED-1
      RN(I,J)=max(0.001, FRICX(I,J))
C
C
       IF(SH(I,J+1) .LT. -500.)S0N(I,J+1)=S0N(I,J)
       IF(SH(I,J-1) .LT. -500.)S0N(I,J-1)=S0N(I,J)
       IF(SH(I-1,J+1) .LT. -500.)S0N(I-1,J+1)=S0N(I-1,J)
       IF(SH(I-1,J-1) .LT. -500.)S0N(I-1,J-1)=S0N(I-1,J)
       SXXX=(S0N(I+1,J)-3.*S0N(I,J)+3.*S0N(I-1,J)-S0N(I-2,J))/DX/DX/DX
       IF(I.EQ.IST+1) THEN
          SXXX=(S0N(I+1,J)-3.*S0N(I,J)+2.*S0N(I-1,J))/DX/DX/DX
       ENDIF
       IF(I.EQ.IED-1) THEN
c          SXXX=(-1.*S0N(I,J)+2.*S0N(I-1,J)-S0N(I-2,J))/DX/DX/DX
c          SXXX=(-2.*S0N(I,J)+3.*S0N(I-1,J)-S0N(I-2,J))/DX/DX/DX
           SXXX=0.0
       ENDIF
c       SYY1=(S0N(I  ,J+1)-2.*S0N(I  ,J)+S0N(I  ,J-1))/DY/DY
c       SYY2=(S0N(I-1,J+1)-2.*S0N(I-1,J)+S0N(I-1,J-1))/DY/DY
c       SXYY=(SYY1-SYY2)/DX
        SXYY=0.0
C
c        IF(I.EQ.IST+1) THEN
c           SXXX=(S0N(I+2,J)-3.*S0N(I+1,J)+3.*S0N(I,J)-S0N(I-1,J))
c     #         /DX/DX/DX
c        ENDIF
c        IF(J.EQ.4.OR.J.EQ.JE+2) THEN
c           SXYY=0.0
c        ENDIF
c------for Madsen(1992)----
c       SXX1=(S0N(I+1,J)+S0N(I,J))/2.
c       SXX2=(S0N(I,J)+S0N(I-1,J))/2.
c       SXX3=(S0N(I-1,J)+S0N(I-2,J))/2.
c       SXX=(SXX1-2.*SXX2+SXX3)/DX/DX
c       SYY=
c     & (0.5*(S0N(I,J+1)+S0N(I-1,J+1))-(S0N(I,J)+S0N(I-1,J))
c     & +0.5*(S0N(I,J-1)+S0N(I-1,J-1)))/DY/DY
c       SXY=0.5*
c     & ((S0N(I,J+1)+S0N(I,J))-(S0N(I-1,J+1)+S0N(I-1,J))
c     & -(S0N(I,J)+S0N(I,J-1))+(S0N(I-1,J)+S0N(I-1,J-1)))
c     & /DX/DY
CZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ
c
c      dedx=(S0N(I,J)-S0N(I-1,J))/dx
c      dedx=max(dedx,-0.5)
c      dedx=min(dedx, 0.5)
c
      FF(I,J)=
C-----------Cconvection term--------------------------------------
     #        -0.125*(Q00(I,J)+Q00(I,J+1)+Q00(I-1,J)+Q00(I-1,J+1)
     #           +ABS(Q00(I,J)+Q00(I,J+1)+Q00(I-1,J)+Q00(I-1,J+1)))
     #           *(P00(I,J)-P00(I,J-1))/DY/TDX(I,J)
     #        -0.125*(Q00(I,J)+Q00(I,J+1)+Q00(I-1,J)+Q00(I-1,J+1)
     #           -ABS(Q00(I,J)+Q00(I,J+1)+Q00(I-1,J)+Q00(I-1,J+1)))
     #           *(P00(I,J+1)-P00(I,J))/DY/TDX(I,J)
C-----------Boussinesq dispersion term---------------------------
     #        +bu*BB*GR*(BHX(I,J)**3)*(SXXX+SXYY)
c     #        +bu*BB*GR*(SHX(I,J)**1)*DSHDX(I,J)*(2.0*SXX+SYY)
c     #        +bu*BB*GR*(SHX(I,J)**1)*DSHDY(I,J)*SXY
C-----------Breaking wave dissipation term-----------------------
c     #   +0.5*DSP(I,J)/DX/DX*(P00(I-1,J)-2.*P00(I,J)+P00(I+1,J))
c     #   *CVX(i,j)*CVX(i-1,j)*CVX(i+1,j)
c-----------Sponge layer ----------------------------------------
     #   -0.5*EPS(I,J)*P00(I,J)
C-----------BOTTOM FRICTION -------------------------------------
     #   -RN(I,J)
     #       *P00(I,J)/TDX(I,J)*SQRT(Q00(I,J)**2+P00(I,J)**2)
C-----------Wind-----------
     #         -TDX(I,J)/1030.0*DPDX(i,j)*taper
     #         +TSX(I,J)/1030.0*taper
CZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ
c      F2S(I,J)=bu*(BB+1.0/3.0)*BHX(I,J)*BHX(I,J)/DX/DY
c     #        *(Q00(I,J+1)-Q00(I-1,J+1)
c     #         -Q00(I,J  )+Q00(I-1,J  ))
CZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ
c
      ALP1=   -bu*BHX(I,J)*BHX(I,J)*(BB+1.0/3.0)/DX/DX
c     #        +bu/6.0/DX*DSHDX(I,J)*TDX(I-1,J)
c-----pressure forcing term--------
c     #    -GR/DX/DX/2.0*TDX(I,J)*DT*DT
c----------------------------------
     #    -1.0*DSP(I,J)/DX/DX*DT
C---------convection PP-terms ---------------------------------
c     #    -0.5*DT/DX*P00(I-1,J)/TDX(I-1,J)
     #    -0.5*DT/DX*(P00(I,J)+ABS(P00(I,J)))/TDX(I,J)
C
      ALP2=1.0+bu*2.0*BHX(I,J)*BHX(I,J)*(BB+1.0/3.0)/DX/DX
c-----pressure force term  --------
c     #    +GR/DX/DX*TDX(I,J)*DT*DT
c------ breaking dispersion -------
     #    +1.0*2.0*DSP(I,J)/DX/DX*DT
c----- convection term ------------------
     #    +DT/DX*ABS(P00(I,J))/TDX(I,J)
c-----------Sponge layer ----------------------------------------
     #   +0.5*EPS(I,J)
C
      ALP3=   -bu*BHX(I,J)*BHX(I,J)*(BB+1.0/3.0)/DX/DX
c     #        -bu/6.0/DX*DSHDX(I,J)*TDX(I+1,J)
c-----pressure forcing term--------
c     #    -GR/DX/DX/2.0*TDX(I,J)*DT*DT
c---------------------------------
     #    -1.0*DSP(I,J)/DX/DX*DT
C---------convection PP-terms ---------------------------------
c     #    +0.5*DT/DX*P00(I+1,J)/TDX(I+1,J)
     #    +0.5*DT/DX*(P00(I,J)-ABS(P00(I,J)))/TDX(I,J)
c
c
c
c      if(I.EQ.IE+2) then
c      ALP1=   -bu*BHX(I,J)*BHX(I,J)*(BB+1.0/3.0)/DX/DX
cc     #        +bu/6.0/DX*DSHDX(I,J)*TDX(I-1,J)
cc-----pressure forcing term--------
cc     #    -GR/DX/DX/2.0*TDX(I,J)*DT*DT
cc----------------------------------
c     #    -1.0*DSP(I,J)/DX/DX*DT
cC---------convection PP-terms ---------------------------------
cc     #    -0.5*DT/DX*P00(I-1,J)/TDX(I-1,J)
c     #    -0.5*DT/DX*(P00(I,J)+ABS(P00(I,J)))/TDX(I,J)
cc
c      ALP3=   -bu*BHX(I,J)*BHX(I,J)*(BB+1.0/3.0)/DX/DX
cc     #        -bu/6.0/DX*DSHDX(I,J)*TDX(I+1,J)
cc-----pressure forcing term--------
cc     #    -GR/DX/DX/2.0*TDX(I,J)*DT*DT
cc---------------------------------
c     #    -1.0*DSP(I,J)/DX/DX*DT
cC---------convection PP-terms ---------------------------------
cc     #    +0.5*DT/DX*P00(I+1,J)/TDX(I+1,J)
cc     #    +0.5*DT/DX*(P00(I,J)-ABS(P00(I,J)))/TDX(I,J)
cc
c      ALP2=1.0+bu*2.0*BHX(I,J)*BHX(I,J)*(BB+1.0/3.0)/DX/DX
cc-----pressure force term  --------
cc     #    +GR/DX/DX*TDX(I,J)*DT*DT
cc------ breaking dispersion -------
c     #    +1.0*2.0*DSP(I,J)/DX/DX*DT
cc----- convection term ------------------
cc     #    +DT/DX*ABS(P00(I,J))/TDX(I,J)
c     #    +0.5*DT/DX*(P00(I,J)+ABS(P00(I,J)))/TDX(I,J)
cc-----------Sponge layer ----------------------------------------
c     #   +0.5*EPS(I,J)
c      endif
c
c
c
      ALP4=-P00(I,J)
     #     +bu*BHX(I,J)*BHX(I,J)*(BB+1.0/3.0)/DX/DX
     #        *(P00(I+1,J)-2.0*P00(I,J)+P00(I-1,J))
c     #     -bu/6.0/DX*DSHDX(I,J)*(P00(I+1,J)-P00(I-1,J))
     #     -DT*FF(I,J)
     #     +GR/DX*DT*TDX(I,J)*((S00(I,J)-S00(I-1,J)))
c     #                 -0.5*DT*(DQQ(I,J)-DQQ(I-1,J)))    
c     #     -(F2S(I,J)-F20(I,J))
C
C
C
      IF(I.EQ.IST+1) THEN
CCCC:::::ALP4=ALP4+ALP1*P00(IST,J):::::::
         AR(IST+2)=-ALP3/ALP2
         BR(IST+2)=-(ALP4+ALP1*P0N(IST,J))/ALP2
      ELSEIF(I.EQ.IED-1) THEN
CCCC:::::ALP4=ALP4+ALP3*P0N(IED,J):::::::
         AR(IED)=-ALP3/(ALP1*AR(I)+ALP2)
         BR(IED)=-(ALP1*BR(I)+ALP4+ALP3*P0N(IED,J))/(ALP1*AR(I)+ALP2)
      ELSE
         AR(I+1)=-ALP3/(ALP1*AR(I)+ALP2)
         BR(I+1)=-(ALP1*BR(I)+ALP4)/(ALP1*AR(I)+ALP2)
      ENDIF
C
   20 CONTINUE
C
C----------- 2ND SWEEP -----------------------
C
      P0N(ied-1,j)=BR(ied)
      DO 30 I=IED-2,IST+1,-1
      P0N(I,J)=AR(I+1)*P0N(I+1,J)+BR(I+1)
   30 CONTINUE
C---------------------------------------------
C
      RETURN
      END
C
C:::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE STEPY(I,JST,JED)
c---- corrector step for P----
C:::::::::::::::::::::::::::::::::::::::::::::
      PARAMETER (MX=900,MY=900)
      COMMON /PARA0/KMAX,IS,IE,JS,JE
      COMMON /PARA1/DT,DX,DY
      COMMON /WAVE0/E0,TERM,THETA
      COMMON /FLUXI/P00(MX,MY),P0N(MX,MY)
      COMMON /FLUXJ/Q00(MX,MY),Q0N(MX,MY)
      COMMON /SURF0/S00(MX,MY),S0N(MX,MY)
      COMMON /DEPTH/SH(MX,MY),SHX(MX,MY),SHY(MX,MY),TIDE
      COMMON /SLOPES/ DSHDX(MX,MY),DSHDY(MX,MY)
      COMMON /BOUSS/ BB,BB3
      COMMON /BREAK/ DSP(MX,MY),SLOP,JBRK
      COMMON /BACKF/ IBKF
      COMMON /INCD0/ETDAT(0:150000),IREG
      COMMON /FRIC0/ FLOS,RN1(MX,MY),RN2(MX,MY)
      COMMON /FRICT/ FRIC(MX,MY),FRICX(MX,MY),FRICY(MX,MY)
      COMMON /SCHM/ ISCHM
      COMMON /EPPA/ OV(MX,MY),OVA(MX,MY),HC,EP(MX),EPA(MX)
      COMMON /KYUSHU/ EPS(MX,MY),EPS2(MX,MY),IO,JO,R,ETHE
      COMMON /FG/ FF(MX,MY),GG(MX,MY)
      COMMON /PPQQ/ PP0(MX,MY),QQ0(MX,MY)
      COMMON /TDP/ TD(MX,MY),TDX(MX,MY),TDY(MX,MY)
      COMMON /BSQD/ BHX(MX,MY),BHY(MX,MY)
      COMMON /CONV/ CVX(MX,MY),CVY(MX,MY)
      COMMON /SHEAR/ TSX(MX,MY),TSY(MX,MY)
      COMMON /PRSUR/ PSR(MX,MY),DPDX(MX,MY),DPDY(MX,MY)
      COMMON /taper/ taper
      COMMON /DPQ/ DPP(MX,MY),DQQ(MX,MY)
C
      DIMENSION AR(MY),BR(MY),RN(MX,MY)
C
      GR=9.8
      BB=1.0/21.0
c      IF(TERM.GE.20.0) THEN
        bu=0.0
c      ELSE
C        bu=1.0
c      ENDIF
C
      DO 14 L=2,JE+3
      AR(L)=0.0
      BR(L)=0.0
   14 CONTINUE
C###################################################################
C#####BOUNDARY CONDITION @I=IST#####################################
      IF(JST.GT.3) THEN
         Q0N(I,JST)=0.0
      ELSE
c         Q0N(I,JST)=-S0N(I,JST)*sqrt(9.8*SH(I,JST))
         Q0N(I,JST)=0.0
      ENDIF
C##### BOUNDARY CONDITION @I=IED #######################################
       IF(JED.EQ.JE+3) THEN
c          Q0N(I,JED)=S0N(I,JED-1)*sqrt(9.8*SH(I,JED-1))
          Q0N(I,JED)=0.0
       ELSE
             Q0N(I,JED)=0.0
             Q00(I,JED)=0.0
       ENDIF
C
C*********************@CALCULATION START *****************************
      DO 20 J=JST+1,JED-1
      RN(I,J)=max(0.001, FRICY(I,J))
C
C
       IF(SH(I+1,J) .LT. -500.)S0N(I+1,J)=S0N(I,J)
       IF(SH(I-1,J) .LT. -500.)S0N(I-1,J)=S0N(I,J)
       IF(SH(I+1,J-1) .LT. -500.)S0N(I+1,J-1)=S0N(I+1,J)
       IF(SH(I-1,J-1) .LT. -500.)S0N(I-1,J-1)=S0N(I,J-1)
       SYYY=(S0N(I,J+1)-3.*S0N(I,J)+3.*S0N(I,J-1)-S0N(I,J-2))/DY/DY/DY
       IF(J.EQ.JST+1) THEN
          SYYY=(S0N(I,J+1)-3.*S0N(I,J)+2.*S0N(I,J-1))/DY/DY/DY
       ENDIF
       IF(J.EQ.JED-1) THEN
c          SYYY=(-1.*S0N(I,J)+2.*S0N(I,J-1)-S0N(I,J-2))/DY/DY/DY
c          SYYY=(-2.*S0N(I,J)+3.*S0N(I,J-1)-S0N(I,J-2))/DY/DY/DY
           SYYY=0.0
       ENDIF
c       SXX1=(S0N(I+1,J  )-2.*S0N(I  ,J)+S0N(I-1,J  ))/DX/DX
c       SXX2=(S0N(I+1,J-1)-2.*S0N(I,J-1)+S0N(I-1,J-1))/DX/DX
c       SYXX=(SXX1-SXX2)/DY
        SYXX=0.0
C
      GG(I,J)=
C-----------Cconvection term--------------------------------------
     #        -0.125*(P00(I,J)+P00(I+1,J)+P00(I,J-1)+P00(I+1,J-1)
     #           +ABS(P00(I,J)+P00(I+1,J)+P00(I,J-1)+P00(I+1,J-1)))
     #           *(Q00(I,J)-Q00(I-1,J))/DX/TDY(I,J)
     #        -0.125*(P00(I,J)+P00(I+1,J)+P00(I,J-1)+P00(I+1,J-1)
     #           -ABS(P00(I,J)+P00(I+1,J)+P00(I,J-1)+P00(I+1,J-1)))
     #           *(Q00(I+1,J)-Q00(I,J))/DX/TDY(I,J)
C-----------Boussinesq dispersion term---------------------------
     #        +bu*BB*GR*(BHY(I,J)**3)*(SYYY+SYXX)
c     #        +bu*BB*GR*(SHY(I,J)**1)*DSHDY(I,J)*(2.0*SYY+SXX)
c     #        +bu*BB*GR*(SHY(I,J)**1)*DSHDX(I,J)*SYX
C-----------Breaking wave dissipation term-----------------------
c     #   +0.5*DSP(I,J)/DY/DY*(Q00(I,J-1)-2.*Q00(I,J)+Q00(I,J+1))
c     #   *CVY(I,J)*CVY(I,J-1)*CVY(I,J+1)
c-----------Sponge layer ----------------------------------------
     #   -0.5*EPS(I,J)*Q00(I,J)
C-----------BOTTOM FRICTION -------------------------------------
     #   -RN(I,J)
     #       *Q00(I,J)/TDY(I,J)*SQRT(Q00(I,J)**2+P00(I,J)**2)
C-----------Wind-----------
     #         -TDY(I,J)/1030.0*DPDY(i,j)*taper
     #         +TSY(I,J)/1030.0*taper
CZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ
c      G2S(I,J)=bu*(BB+1.0/3.0)*BHY(I,J)*BHY(I,J)/DY/DX
c     #        *(P00(I+1,J)-P00(I+1,J-1)
c     #         -P00(I,J  )+P00(I  ,J-1))
CZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ
c
      ALP1=   -bu*BHY(I,J)*BHY(I,J)*(BB+1.0/3.0)/DY/DY
c     #        +bu/6.0/DY*DSHDY(I,J)*TDY(I-1,J)
c-----pressure forcing term--------
c     #    -GR/DY/DY/2.0*TDY(I,J)*DT*DT
c----------------------------------
     #    -1.0*DSP(I,J)/DY/DY*DT
C---------convection PP-terms ---------------------------------
c     #    -0.5*DT/DY*Q00(I-1,J)/TDY(I-1,J)
     #    -0.5*DT/DY*(Q00(I,J)+ABS(Q00(I,J)))/TDY(I,J)
C
      ALP2=1.0+bu*2.0*BHY(I,J)*BHY(I,J)*(BB+1.0/3.0)/DY/DY
c-----pressure force term  --------
c     #    +GR/DY/DY*TDY(I,J)*DT*DT
c----------------------------------
     #    +1.0*2.0*DSP(I,J)/DY/DY*DT
c----- convection term ------------------
     #    +DT/DY*ABS(Q00(I,J))/TDY(I,J)
c-----------Sponge layer ----------------------------------------
     #   +0.5*EPS(I,J)
C
      ALP3=   -bu*BHY(I,J)*BHY(I,J)*(BB+1.0/3.0)/DY/DY
c     #        -bu/6.0/DY*DSHDY(I,J)*TDY(I+1,J)
c-----pressure forcing term--------
c     #    -GR/DY/DY/2.0*TDY(I,J)*DT*DT
c---------------------------------
     #    -1.0*DSP(I,J)/DY/DY*DT
C---------convection PP-terms ---------------------------------
c     #    +0.5*DT/DY*Q00(I,J+1)/TDY(I,J+1)
     #    +0.5*DT/DY*(Q00(I,J)-ABS(Q00(I,J)))/TDY(I,J)
c
c
c
      ALP4=-Q00(I,J)
     #     +bu*BHY(I,J)*BHY(I,J)*(BB+1.0/3.0)/DY/DY
     #        *(Q00(I,J+1)-2.0*Q00(I,J)+Q00(I,J-1))
c     #     -bu/6.0/DY*DSHDY(I,J)*(Q00(I,J+1)-Q00(I,J-1))
     #     -dt*GG(I,J)
     #     +GR/DY*DT*TDY(I,J)*((S00(I,J)-S00(I,J-1)))
c     #                 -0.5*DT*(DPP(I,J)-DPP(I,J-1)))    
c     #     -(G2S(I,J)-G20(I,J))
C
C
C
      IF(J.EQ.JST+1) THEN
CCCC:::::ALP4=ALP4+ALP1*Q00(I,JST):::::::
         AR(JST+2)=-ALP3/ALP2
         BR(JST+2)=-(ALP4+ALP1*Q0N(I,JST))/ALP2
      ELSEIF(J.EQ.JED-1) THEN
CCCC:::::ALP4=ALP4+ALP3*Q0N(I,JED):::::::
         AR(JED)=-ALP3/(ALP1*AR(J)+ALP2)
         BR(JED)=-(ALP1*BR(J)+ALP4+ALP3*Q0N(I,JED))/(ALP1*AR(J)+ALP2)
      ELSE
         AR(J+1)=-ALP3/(ALP1*AR(J)+ALP2)
         BR(J+1)=-(ALP1*BR(J)+ALP4)/(ALP1*AR(J)+ALP2)
      ENDIF
C
   20 CONTINUE
C
C----------- 2ND SWEEP -----------------------
C
      Q0N(I,JED-1)=BR(JED)
      DO 30 J=JED-2,JST+1,-1
      Q0N(I,J)=AR(J+1)*Q0N(I,J+1)+BR(J+1)
   30 CONTINUE
C---------------------------------------------
C
      RETURN
      END
C
C:::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE DSPCAL
C:::::::::::::::::::::::::::::::::::::::::::::::::::
      PARAMETER (MX=900,MY=900)
      COMMON /PARA0/KMAX,IS,IE,JS,JE
      COMMON /BREAK/ DSP(MX,MY),SLOP,JBRK
      COMMON /QSB/ PUP(MX,MY),QSBX(MX,MY),QSBY(MX,MY),USC(MX,MY)
      COMMON /TDP/ TD(MX,MY),TDX(MX,MY),TDY(MX,MY)
C
      DO 10 J=1,JE+4
      DO 10 I=1,IE+4
C       DSP(I,J)=0.4*MAX(USC(I,J),0.001)*MIN(TD(I,J),5.0)
       DSP(I,J)=0.0
   10 CONTINUE
C
      RETURN
      END
C
C:::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE DPREAD
C:::::::::::::::::::::::::::::::::::::::::::::::::::::
      PARAMETER (MX=900,MY=900)
      COMMON /PARA1/DT,DX,DY
      COMMON /PARA0/KMAX,IS,IE,JS,JE
      COMMON /DEPTH/SH(MX,MY),SHX(MX,MY),SHY(MX,MY),TIDE
      COMMON /SLOPES/ DSHDX(MX,MY),DSHDY(MX,MY)
      COMMON /DLIMT/ LIMT,DLIM
      COMMON /BLCK3/MAP(MX,MY)
      COMMON /GEOG/ BL(MX,MY)
      COMMON /GEO2/ DP0(MX,MY),DP1(MX,MY)
      COMMON /CONV/ CVX(MX,MY),CVY(MX,MY)
      COMMON /BSQD/ BHX(MX,MY),BHY(MX,MY)
C
      OPEN(50,file='depth.txt')
c      OPEN(53,file='depth1.dat')
C
      read(50,*)
      do i=3,ie+2
c       read(50,'(800f9.0)')(DP0(i,j),j=3,je+2)
c       read(50,*)(DP0(i,j),j=3,je+2)
       read(50,*)(DP0(i,j),j=2,je+2)
c       read(53,'(600f9.0)')(DP1(i,j),j=3,je+2)
        do j=3,je+2
           dp1(i,j)=dp0(i,j)
        enddo
      end do
      close(50)
c      close(53)
C
      do i=3,ie+2
       do j=3,je+2
            dp0(i,j)=max(-500.0, dp0(i,j))
            dp1(i,j)=max(-500.0, dp1(i,j))
            SH(I,J)= TIDE-dp0(I,J)
c            BL(I,J)= -SH(I,J)
            BL(I,J)= min(-SH(I,J), 100.0)
       end do
      end do
C
      DO I=3,IE+2
         SH(I,   1)=SH(I,   3)
         SH(I,   2)=SH(I,   3)
         SH(I,JE+3)=SH(I,JE+2)
         SH(I,JE+4)=SH(I,JE+2)
      END DO
C
      DO J=3,JE+2
         SH(1   ,J)=SH(3   ,J)
         SH(2   ,J)=SH(3   ,J)
         SH(IE+3,J)=SH(IE+2,J)
         SH(IE+4,J)=SH(IE+2,J)
      END DO
C
CCCCC X[̒`
      DO 30 J=1,JE+4
      SHX(1,J)=SH(1,J)
      DSHDX(1,J)=0.0
      DO 40 I=2,IE+4
        CVX(I,J)=1.0
        IF(ABS(SH(I,J)-SH(I-1,J)).GE.0.2*dx) THEN
          CVX(I,J)=0.0
        ENDIF
      SHX(I,J)=(SH(I,J)+SH(I-1,J))/2.
      DSHDX(I,J)=(SH(I,J)-SH(I-1,J))/DX
      IF((SH(I-1,J).GT.-500.).AND.(SH(I,J).LT.-500.)) THEN
         SHX(I,J)=SH(I-1,J)
         DSHDX(1,J)=0.0
      ENDIF
      IF((SH(I-1,J).LT.-500.).AND.(SH(I,J).GT.-500.)) THEN
         SHX(I,J)=SH(I,J)
         DSHDX(1,J)=0.0
      ENDIF
      IF(DSHDX(I,J).gt. 0.1) DSHDX(I,J)= 0.1
      IF(DSHDX(I,J).lt.-0.1) DSHDX(I,J)=-0.1
      IF(I.LE.3.or.I.GE.IE+3.or.J.LE.3.or.J.GE.JE+3) THEN
          CVX(I,J)=0.0
      ENDIF
   40 CONTINUE
   30 CONTINUE
CCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCC Y[̒` CCCCC
      DO 35 I=1,IE+4
      SHY(I,1)=SH(I,1)
      DSHDY(I,1)=0.0
      DO 45 J=2,JE+4
        CVY(I,J)=1.0
        IF(ABS(SH(I,J)-SH(I,J-1)).GE.0.2*dy) THEN
          CVY(I,J)=0.0
        ENDIF
      SHY(I,J)=(SH(I,J)+SH(I,J-1))/2.
      DSHDY(I,J)=(SH(I,J)-SH(I,J-1))/DY
      IF((SH(I,J-1).GT.-500.).AND.(SH(I,J).LT.-500.)) THEN
          SHY(I,J)=SH(I,J-1)
          DSHDY(I,J)=0.0
      ENDIF
      IF((SH(I,J-1).LT.-500.).AND.(SH(I,J).GT.-500.)) THEN
          SHY(I,J)=SH(I,J)
          DSHDY(I,J)=0.0
      ENDIF
      IF(DSHDY(I,J).gt. 0.1) DSHDY(I,J)= 0.1
      IF(DSHDY(I,J).lt.-0.1) DSHDY(I,J)=-0.1
      IF(I.LE.3.or.I.GE.IE+3.or.J.LE.3.or.J.GE.JE+3) THEN
          CVY(I,J)=0.0
      ENDIF
   45 CONTINUE
   35 CONTINUE
C
      DO I=1,IE+4
      DO J=1,JE+4
         BHX(I,J)=MAX(SHX(I,J),0.01)
         BHY(I,J)=MAX(SHY(I,J),0.01)
      END DO
      END DO
C
CCCCCCCCCCCCCCCCCCCCCCCCCCC
c
      RETURN
      END
C::::::::::::::::::::::::::::::::::::::
      SUBROUTINE MPREAD
C::::::::::::::::::::::::::::::::::::::
      PARAMETER (MX=900,MY=900)
      COMMON /PARA0/KMAX,IS,IE,JS,JE
      COMMON /BLCK3/MAP(MX,MY)
      COMMON /DEPTH/SH(MX,MY),SHX(MX,MY),SHY(MX,MY),TIDE
C
      OPEN(52,FILE='map.dat')
      DO 10 I=3,IE+2
      READ(52,'(800I1)')(MAP(I,J),J=3,JE+2)
   10 CONTINUE
      CLOSE(52)
      DO 20 I=1,IE+4
        DO 20 J=1,JE+4
          IF(I.LT.3)MAP(I,J)=MAP(3,J)
          IF(J.LT.3)MAP(I,J)=MAP(I,3)
          IF(I.GT.IE+2)MAP(I,J)=MAP(IE+2,J)
          IF(J.GT.JE+2)MAP(I,J)=MAP(I,JE+2)
   20 CONTINUE
C
C
      RETURN
      END
C::::::::::::::::::::::::::::::::::::::
      SUBROUTINE RNREAD
C::::::::::::::::::::::::::::::::::::::
      PARAMETER (MX=900,MY=900)
      COMMON /PARA0/KMAX,IS,IE,JS,JE
      COMMON /FRIC0/ FLOS,RN1(MX,MY),RN2(MX,MY)
C
      do i=1,ie+4
      do j=1,je+4
         RN1(i,j)=0.005
         RN2(i,j)=0.005
      end do
      end do
C
      RETURN
      END
C*******************************************************************
      SUBROUTINE WAVE(T,D,WK)
C*******************************************************************
C------------- WAVE --------------------------------------------------
C
      G=9.8
      DATA PI2/6.283185/
      WL0 = G * T * T / PI2
      DL0 = D / WL0
      X = PI2 * DL0
       IF(DL0.LT.0.2) THEN
        Y = SQRT(X) * ( 1. + X / 6. * ( 1. + X / 5. ) )
       ELSE
        YP = X * ( 1. + 1.26 * EXP(-1.84*X) )
        ST = EXP(-2.*YP)
        Y  = X * ( 1. + 2. * ST * ( 1. + ST ) )
       ENDIF
      WK = Y / D
C
      RETURN
      END
C********************************************************************
      SUBROUTINE ERIC
c********************************************************************
C     oȐ^
      PARAMETER (MX=900,MY=900)
C
      COMMON /PARA0/KMAX,IS,IE,JS,JE
      COMMON /BOUSS/ BB,BB3
      COMMON /PARA1/DT,DX,DY
      COMMON /WAVE0/E0,TERM,THETA
      COMMON /DEPTH/SH(MX,MY),SHX(MX,MY),SHY(MX,MY),TIDE
      COMMON /COEF0/GR,PAI
      COMMON /BLCK3/MAP(MX,MY)
      COMMON /KYUSHU/ EPS(MX,MY),EPS2(MX,MY),IO,JO,R,ETHE
C
      PAI=3.141592
      GR=9.8
CCCCCCCCCCC\Oʂ̃X|Ww CCCCCCCCCCCCCCCCCCCCC
C
      DO 20 I=3,IE+2
      DO 10 J=3,JE+2
       IF(MAP(I,J).LE.0) THEN
         EPS(I,J)=0.0
       ELSE
         EPS(I,J)=0.0
       END IF
   10 CONTINUE
   20 CONTINUE
C
CCCCCCCCCCCE˖@ɂX|Ww CCCCCCCCCCCCCCC
      FHABAX=REAL(IO)*DX
      FHABAY=REAL(JO)*DY
      DO 30 J=1,JE+4
      DO 40 I=IE+3-IO,IE+2
        IF(SH(I,J) .LT. 0.)GOTO 40
        EM=ETHE*SQRT(GR/SH(I,J))
        EPS2(I,J)=R*EM*(COSH(R*REAL(I-(IE+2-IO))*DX/FHABAX)-1)
     &            /2./(SINH(R)-R)
   40 CONTINUE
        EPS2(IE+3,J)=EPS2(IE+2,J)
        EPS2(IE+4,J)=EPS2(IE+2,J)
   30 CONTINUE
C
      DO 50 I=1,IE+4
      DO 60 J=3,JO+2
        IF(SH(I,J) .LT. 0.)GOTO 60
        EM=ETHE*SQRT(GR/SH(I,J))
        EPS2(I,J)=R*EM*(COSH(R*REAL(JO+3-J)*DX/FHABAY)-1)
     &            /2./(SINH(R)-R)
   60 CONTINUE
        EPS2(I,2)=EPS2(I,3)
        EPS2(I,1)=EPS2(I,3)
   50 CONTINUE
C
      DO 70 I=1,IE+4
      DO 80 J=JE+3-JO,JE+2
        IF(SH(I,J) .LT. 0.)GOTO 80
        EM=ETHE*SQRT(GR/SH(I,J))
        EPS2(I,J)=R*EM*(COSH(R*REAL(J-(JE+2-JO))*DX/FHABAY)-1)
     &            /2./(SINH(R)-R)
   80 CONTINUE
        EPS2(I,JE+3)=EPS2(I,JE+2)
        EPS2(I,JE+4)=EPS2(I,JE+2)
   70 CONTINUE
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC--GOSEI
      DO 90 I=1,IE+4
      DO 100 J=1,JE+4
        EPS(I,J)=min(0.5, EPS(I,J)+EPS2(I,J))
  100 CONTINUE
   90 CONTINUE
C
C
      RETURN
      END
C
C
C:::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE INWAVP(kk)
C     Predictor scheme in x-direction
C:::::::::::::::::::::::::::::::::::::::::::::
      PARAMETER (MX=900,MY=900)
      COMMON /PARA0/KMAX,IS,IE,JS,JE
      COMMON /PARA1/DT,DX,DY
      COMMON /BLCK3/MAP(MX,MY)
      COMMON /FLUXI/P00(MX,MY),P0N(MX,MY)
      COMMON /FLUXJ/Q00(MX,MY),Q0N(MX,MY)
      COMMON /SURF0/S00(MX,MY),S0N(MX,MY)
      COMMON /DEPTH/SH(MX,MY),SHX(MX,MY),SHY(MX,MY),TIDE
      COMMON /INCD0/ETDAT(0:150000),IREG
      COMMON /INCD1/ETA(240,MY),ETU(240,MY),ETV(240,MY)
      COMMON /TDP/ TD(MX,MY),TDX(MX,MY),TDY(MX,MY)
C
      GR=9.8
C
C
       taper=1.0
c
      DO 100 J=3,JE+2
C
       IF(MAP(3,J).EQ.2.or.sh(3,j).le.0.1) THEN
         P0N(3,J)=0.0
         Q0N(2,J)=0.0
         GOTO 100
       END IF
C
       IF(IREG.eq.3) then
         P0N(3,J)=P00(4,J)
         Q0N(3,J)=0.0
       ELSE
C
       DQQ=Q00(3,J)-ETV(KK-1,J)*taper
       DPP=P00(4,J)-ETU(KK-1,J)*taper
       DSS=S00(3,J)-ETA(KK-1,J)*taper
       ADPQ=sqrt(DPP*DPP+DQQ*DQQ)
       CCC=SQRT(GR*SH(3,J))
        if(adpq.le.0.0001) then
          P0N(3,J)=ETU(KK,J)*taper
     #            -DSS*SQRT(GR/SH(3,J))*TD(3,J)
          Q0N(2,J)=ETV(KK,J)*taper
        else
          P0N(3,J)=ETU(KK,J)*taper
     #            -DSS*SQRT(GR/SH(3,J))*TD(3,J)*abs(dpp/adpq)
          Q0N(2,J)=ETV(KK,J)*taper
     #            -DSS*SQRT(GR/SH(3,J))*TD(3,J)*abs(dqq/adpq)
        endif
c          P0N(3,J)=ETU(kk,j)
c          Q0N(2,J)=ETV(kk,j)
      ENDIF
  100 CONTINUE

C
      P0N(3,2)   =P0N(3,3)
      P0N(3,JE+3)=P0N(3,JE+2)
      P0N(3,JE+4)=P0N(3,JE+2)
      Q0N(3,2)   =Q0N(3,3)
      Q0N(3,JE+3)=Q0N(3,JE+2)
      Q0N(3,JE+4)=Q0N(3,JE+2)
C
      RETURN
      END
C:::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE INWAVC(KK)
C     Predictor scheme in x-direction
C:::::::::::::::::::::::::::::::::::::::::::::
      PARAMETER (MX=900,MY=900)
      COMMON /PARA0/KMAX,IS,IE,JS,JE
      COMMON /PARA1/DT,DX,DY
      COMMON /BLCK3/MAP(MX,MY)
      COMMON /FLUXI/P00(MX,MY),P0N(MX,MY)
      COMMON /FLUXJ/Q00(MX,MY),Q0N(MX,MY)
      COMMON /SURF0/S00(MX,MY),S0N(MX,MY)
      COMMON /DEPTH/SH(MX,MY),SHX(MX,MY),SHY(MX,MY),TIDE
      COMMON /INCD0/ETDAT(0:150000),IREG
      COMMON /INCD1/ETA(240,MY),ETU(240,MY),ETV(240,MY)
      COMMON /TDP/ TD(MX,MY),TDX(MX,MY),TDY(MX,MY)
C
      GR=9.800
C
C
       taper=1.0
C
      DO 100 J=3,JE+2
C
       IF(MAP(3,J).EQ.2.or.sh(3,j).le.0.1) THEN
         P0N(3,J)=0.0
         Q0N(2,J)=0.0
         GOTO 100
       END IF
C
       IF(IREG.eq.3) then
         P0N(3,J)=P0N(4,J)
         Q0N(3,J)=0.0
       ELSE
C
       DQQ=Q0N(3,J)-ETV(KK,J)*taper
       DPP=P0N(4,J)-ETU(KK,J)*taper
       DSS=S0N(3,J)-ETA(KK,J)*taper
       ADPQ=sqrt(DPP*DPP+DQQ*DQQ)
       CCC=SQRT(GR*SH(3,J))
       if(adpq.le.0.0001) then
          P0N(3,J)=ETU(KK,J)*taper
     #            -DSS*SQRT(GR/SH(3,J))*TD(3,J)
          Q0N(2,J)=ETV(KK,J)*taper
        else
          P0N(3,J)=ETU(KK,J)*taper
     #            -DSS*SQRT(GR/SH(3,J))*TD(3,J)*abs(dpp/adpq)
          Q0N(2,J)=ETV(KK,J)*taper
     #            -DSS*SQRT(GR/SH(3,J))*TD(3,J)*abs(dqq/adpq)
C          Q0N(2,J)=ETV(KK,J)*taper
        endif
c          P0N(3,J)=ETU(kk,j)
c          Q0N(2,J)=ETV(kk,j)
      ENDIF
  100 CONTINUE
cC
      P0N(3,2)   =P0N(3,3)
      P0N(3,JE+3)=P0N(3,JE+2)
      P0N(3,JE+4)=P0N(3,JE+2)
      Q0N(3,2)   =Q0N(3,3)
      Q0N(3,JE+3)=Q0N(3,JE+2)
      Q0N(3,JE+4)=Q0N(3,JE+2)
C
      RETURN
      END
C
C
C********************************************************************
      subroutine FRICTION
C********************************************************************
      PARAMETER (MX=900,MY=900)
      COMMON /PARA0/KMAX,IS,IE,JS,JE
      COMMON /PARA1/DT,DX,DY
      COMMON /FLUXI/P00(MX,MY),P0N(MX,MY)
      COMMON /FLUXJ/Q00(MX,MY),Q0N(MX,MY)
      COMMON /TDP/ TD(MX,MY),TDX(MX,MY),TDY(MX,MY)
      COMMON /TDMIN/ TDMIN
      COMMON /SPARA/ D50,wf,taucr,rmuk,NSED,tanfs,tanfm,dts,za
      COMMON /RHOS/ RHO,RHOS,S
      COMMON /FRICT/ FRIC(MX,MY),FRICX(MX,MY),FRICY(MX,MY)
C
C
      DO 100 I=2,IE+3
      DO 110 J=2,JE+3
C
      IF(TD(I,J).LE.TDMIN) THEN
         FRIC(I,J)=0.0
      ELSE
         UV=0.5*SQRT(
     #      (P0N(I+1,J)/TDX(I+1,J)+P0N(I,J)/TDX(I,J))**2
     #     +(Q0N(I,J+1)/TDY(I,J+1)+Q0N(I,J)/TDY(I,J))**2)
C
         Re=MAX(1000.0,UV*4.0*TD(I,J)/rmuk)
C         call Moody(Re, 0.25*D50/TD(I,J), FRIC(I,J))
C
      ENDIF
C
      if(i.ge.3) then
        FRICX(I,J)=0.5*(FRIC(I,J)+FRIC(I-1,J))
      else
        FRICX(I,J)=FRIC(I,J)
      endif
      if(j.ge.3) then
        FRICY(I,J)=0.5*(FRIC(I,J)+FRIC(I,J-1))
      else
        FRICY(I,J)=FRIC(I,J)
      endif
C
  110 continue
  100 continue
C
C
      RETURN
      END
C
C
C********************************************************************
      subroutine FRICT2
C********************************************************************
      PARAMETER (MX=900,MY=900)
      COMMON /PARA0/KMAX,IS,IE,JS,JE
      COMMON /PARA1/DT,DX,DY
      COMMON /FLUXI/P00(MX,MY),P0N(MX,MY)
      COMMON /FLUXJ/Q00(MX,MY),Q0N(MX,MY)
      COMMON /TDP/ TD(MX,MY),TDX(MX,MY),TDY(MX,MY)
      COMMON /TDMIN/ TDMIN
      COMMON /SPARA/ D50,wf,taucr,rmuk,NSED,tanfs,tanfm,dts,za
      COMMON /RHOS/ RHO,RHOS,S
      COMMON /FRICT/ FRIC(MX,MY),FRICX(MX,MY),FRICY(MX,MY)
      COMMON /RNESS/ RKS(MX,MY)
      COMMON /QSB/ PUP(MX,MY),QSBX(MX,MY),QSBY(MX,MY),USC(MX,MY)
      COMMON /BLCK3/MAP(MX,MY)
C
C
      DO 100 I=2,IE+3
      DO 110 J=2,JE+3
C
       IF(MAP(I,J).EQ.1) THEN
          FRIC(I,J)=0.01
       ELSE
          FRIC(I,J)=0.01
       ENDIF
C
c      IF(TD(I,J).LE.TDMIN) THEN
c         FRIC(I,J)=0.01
c      ELSE
c         UV=0.5*SQRT(
c     #      (P0N(I+1,J)/TDX(I+1,J)+P0N(I,J)/TDX(I,J))**2.0
c     #     +(Q0N(I,J+1)/TDY(I,J+1)+Q0N(I,J)/TDY(I,J))**2.0)
cC
c      RKS(I,J)=D50*(2.0
c     #        +4.5*max(0.0,usc(i,j)**2.0-taucr/rho)/(s-1.0)/9.8/D50)
cC
c         IF(UV.LE.1.0e-10) THEN
c           FRIC(I,J)=0.01
c         ELSE
c         USC(I,J)=UV*0.4/(alog(30.0*TD(i,j)/RKS(I,J))-1.0)
c         FRIC(I,J)=8.0*USC(I,J)*USC(I,J)/UV/UV
c         ENDIF
cC
c      ENDIF
cC
      if(i.ge.3) then
        FRICX(I,J)=0.5*(FRIC(I,J)+FRIC(I-1,J))
      else
        FRICX(I,J)=FRIC(I,J)
      endif
      if(j.ge.3) then
        FRICY(I,J)=0.5*(FRIC(I,J)+FRIC(I,J-1))
      else
        FRICY(I,J)=FRIC(I,J)
      endif
C
  110 continue
  100 continue
C
C
      RETURN
      END
C
C
cC######################################################################
c      subroutine wdatin
cC######################################################################
c      PARAMETER (MX=900,MY=900)
c      COMMON /PARA0/KMAX,IS,IE,JS,JE
c      COMMON /PARA1/DT,DX,DY
c      COMMON /PARAW/ TSTART,TEND
c      COMMON /WIND/ TSX(MX,MY),TSY(MX,MY),PSR(MX,MY)
cC
c      TSTART= 80.0*900.0
c      TEND  =160.0*900.0
c      KMAX  =(TEND-TSTART)/DT
cC
cC
c      OPEN(40,file='pin.dat')
c      OPEN(41,file='e1in.dat')
c      OPEN(42,file='e2in.dat')
c      OPEN(43,file='e3in.dat')
c      OPEN(44,file='tsxin.dat')
c      OPEN(45,file='tsyin.dat')
cC
c      do itm=1,240
c         read(40,'(5x,4e12.4)')(PSR0(itm,ks),ks=1,4)
c         read(44,'(5x,4e12.4)')(TSY0(itm,ks),ks=1,4)
c         read(45,'(5x,4e12.4)')(TSX0(itm,ks),ks=1,4)
c         read(41,'(126e12.4)')(   E1(itm,ks),ks=1,43)
c         read(42,'(171e12.4)')(   E2(itm,ks),ks=1,58)
c         read(43,'(126e12.4)')(   E3(itm,ks),ks=1,43)
c      end do
cC
c      close(40)
c      close(41)
c      close(42)
c      close(43)
c      close(44)
c      close(45)
cC
c      return
c      end
C
C
cC######################################################################
c      SUBROUTINE WINDCND(k)
cC######################################################################
c      PARAMETER (MX=900,MY=900)
c      COMMON /PARA0/KMAX,IS,IE,JS,JE
c      COMMON /PARA1/DT,DX,DY
c      COMMON /PARAW/ TSTART,TEND
c      COMMON /WIND/ TSX(MX,MY),TSY(MX,MY),PSR(MX,MY)
C      COMMON /SURF0/S00(MX,MY),S0N(MX,MY)
cC
c      time=TSTART+real(k)*DT
cC
c      itw=INT(time/900.0)
cc      write(6,*)'itw=',itw
cC
c      DO 100 I=3,IE+2
c      DO 200 J=3,JE+2
cC
c         TSX(I,J)=((TSX0(itw  ,1)*real(JE+2-J)
c     #             +TSX0(itw  ,2)*real(J-3))/real(JE-1)*real(IE+2-I)
c     #            +(TSX0(itw  ,3)*real(JE+2-J)
c     #             +TSX0(itw  ,4)*real(J-3))/real(JE-1)*real(I-3)
c     #             )/real(IE-1)*(real(itw)+1.0-time/900.0)
c     #           +((TSX0(itw+1,1)*real(JE+2-J)
c     #             +TSX0(itw+1,2)*real(J-3))/real(JE-1)*real(IE+2-I)
c     #            +(TSX0(itw+1,3)*real(JE+2-J)
c     #             +TSX0(itw+1,4)*real(J-3))/real(JE-1)*real(I-3)
c     #             )/real(IE-1)*(time/900.0-real(itw))
cC
c         TSY(I,J)=((TSY0(itw  ,1)*real(JE+2-J)
c     #             +TSY0(itw  ,2)*real(J-3))/real(JE-1)*real(IE+2-I)
c     #            +(TSY0(itw  ,3)*real(JE+2-J)
c     #             +TSY0(itw  ,4)*real(J-3))/real(JE-1)*real(I-3)
c     #             )/real(IE-1)*(real(itw)+1.0-time/900.0)
c     #           +((TSY0(itw+1,1)*real(JE+2-J)
c     #             +TSY0(itw+1,2)*real(J-3))/real(JE-1)*real(IE+2-I)
c     #            +(TSY0(itw+1,3)*real(JE+2-J)
c     #             +TSY0(itw+1,4)*real(J-3))/real(JE-1)*real(I-3)
c     #             )/real(IE-1)*(time/900.0-real(itw))
cC
c         PSR(I,J)=((PSR0(itw  ,1)*real(JE+2-J)
c     #             +PSR0(itw  ,2)*real(J-3))/real(JE-1)*real(IE+2-I)
c     #            +(PSR0(itw  ,3)*real(JE+2-J)
c     #             +PSR0(itw  ,4)*real(J-3))/real(JE-1)*real(I-3)
c     #             )/real(IE-1)*(real(itw)+1.0-time/900.0)
c     #           +((PSR0(itw+1,1)*real(JE+2-J)
c     #             +PSR0(itw+1,2)*real(J-3))/real(JE-1)*real(IE+2-I)
c     #            +(PSR0(itw+1,3)*real(JE+2-J)
c     #             +PSR0(itw+1,4)*real(J-3))/real(JE-1)*real(I-3)
c     #             )/real(IE-1)*(time/900.0-real(itw))
cC
c  200 CONTINUE
cC
c      mw=(i-1)/10+1
c      mb=i-(mw-1)*10
cC
c      S0S(I,3  )=(E1(itw  ,mw  )*(1.0-0.1*real(mb-1))
c     #           +E1(itw  ,mw+1)*(0.1*real(mb-1))
c     #           )*(real(itw)+1.0-time/900.0)
c     #          +(E1(itw+1,mw  )*(1.0-0.1*real(mb-1))
c     #           +E1(itw+1,mw+1)*(0.1*real(mb-1))
c     #           )*(time/900.0-real(itw))
cC
c      S0S(I,JE+2)=(E3(itw  ,mw  )*(1.0-0.1*real(mb-1))
c     #            +E3(itw  ,mw+1)*(0.1*real(mb-1))
c     #            )*(real(itw)+1.0-time/900.0)
c     #           +(E3(itw+1,mw  )*(1.0-0.1*real(mb-1))
c     #            +E3(itw+1,mw+1)*(0.1*real(mb-1))
c     #            )*(time/900.0-real(itw))
cC
cC
c  100 CONTINUE
cC
c      DO 300 J=3,JE+2
c       nw=(j-1)/10+1
c       nb=j-(nw-1)*10
c       S0S(3,J)=(E2(itw  ,nw  )*(1.0-0.1*real(nb-1))
c     #          +E2(itw  ,nw+1)*(0.1*real(nb-1))
c     #          )*(real(itw)+1.0-time/900.0)
c     #         +(E2(itw+1,nw  )*(1.0-0.1*real(nb-1))
c     #          +E2(itw+1,nw+1)*(0.1*real(nb-1))
c     #          )*(time/900.0-real(itw))
c  300 CONTINUE
cC
c      if(k.eq.100) then
c        open(80,file='tsycal.dat')
c        open(81,file='psrcal.dat')
c        open(82,file='eincal.dat')
c        do i=3,ie+2
c           write(80,'(600e12.4)')(tsy(i,j),j=3,je+2)
c           write(81,'(600e12.4)')(psr(i,j),j=3,je+2)
c           write(82,'(2e12.4)')S0S(i,3),S0S(i,JE+2)
c        enddo
c        close(80)
c        close(81)
c      endif
cC
c      return
c      end
cCc
c
C#####################################################################
      subroutine INHURR
C#####################################################################
      COMMON /PARA0/KMAX,IS,IE,JS,JE
      COMMON /PARA1/DT,DX,DY
      COMMON /HURR/itend,tdt,tt(100),tx(100),ty(100),tp0(100),tr0(100)
Check
      parameter(dlonl=139.7347,dlonr=139.8997,
     #          dlatb= 35.4957,dlatu= 35.7656)
Check
c
      pi=3.141593
      pinf=1013.0
      roua=1.21
c
c read track data from 'track.dat'
c time(minutes), cent_x(m), cent_y(m), cent_pressure(hPa), core radius(m)
c
Check
      open(33,file='TyphoonTrack.dat')
      read(33,*)
      read(33,*)tdt
      read(33,*)
      do 400 itr=1,100
       read(33,*,end=401)tt(itr),dlat,dlon,tp0(itr),trkm
c         ty(itr)=(dlon-dlonl)*DY*120.0
c         tx(itr)=(dlatu-dlat)*DX*120.0
c         ty(itr)=dlon*1000.0
c         tx(itr)=dlat*1000.0
c
         ty(itr)=(dlon-dlonl)*DY*real(JE)/(dlonr-dlonl)
         tx(itr)=(dlatu-dlat)*DX*real(IE)/(dlatu-dlatb)
c
c        tr0(itr)=trkm*1000.0
Check--Kato's model to estimate radius(m)
        R1=0.769*tp0(itr)-650.55
        R2=1.633*tp0(itr)-1471.35
        tr0(itr)=max(R1,R2)*1000.0
c
 400  continue
 401  continue
      itend=itr-1
      do 402 ii=1,itend
 402   write(6,*)tt(ii),ty(ii),tx(ii),tp0(ii),tr0(ii)
      close(33)
C
      return
      end
C
C
cC#####################################################################
c      subroutine INHURR_T
cC#####################################################################
c      COMMON /PARA1/DT,DX,DY
cC      COMMON /HURR/itend,tdt,tt(100),tx(100),ty(100),tp0(100),tr0(100)
cc      COMMON /TAUS0/itend,tmin(200),tsx0(200),tsy0(200)
c      COMMON /ETA0/ etab0(200)
cc
c      open(40,file='HURR_mon.out')
c      open(41,file='e_mon.out')
cc
c      do 400 itr=2,200
c       read(40,'(f8.0,2e15.0)',end=401)tmin(itr),tsx0(itr),tsy0(itr)
c 400  continue
c 401  continue
c      itend=itr-1
c      close(40)
cC
c      do 402 itr=2,itend
c       read(41,'(8x,e15.0)')etab0(itr)
c 402  continue
c      close(41)
cC
c       tmin(1)= 0.0
c       tsx0(1)= tsx0(2)
c       tsy0(1)= tsy0(2)
c      etab0(1)=etab0(2)
cC
c       tmin(itend+1) =  99999.0
c       tsx0(itend+1) =  tsx0(itend)
c       tsy0(itend+1) =  tsy0(itend)
c      etab0(itend+1) = etab0(itend)
cC
c      do 403 ii=1,itend+1
c  403    write(6,'(4f12.3)')tmin(ii),tsx0(ii),tsy0(ii),etab0(ii)
cC
c      return
c      end
cC
C#####################################################################
      subroutine IN_ETAB
C#####################################################################
      PARAMETER (MX=900,MY=900)
      COMMON /PARA1/DT,DX,DY
      COMMON /ETA0/ JEMON,DYEMON,iteta, etab0(500,MY),tmin(500)
      COMMON /DEPTH/SH(MX,MY),SHX(MX,MY),SHY(MX,MY),TIDE
c
Check
        JEMON=1
       DYEMON=1844.14
c
      open(41,file='e_mon.out')
c
c      do 402 itr=2,800
c       read(41,'(f8.0,500e15.0)',end=403)
c     #      tmin(itr),(etab0(itr,J),J=1,JEMON)
c 402  continue
      do 402 itr=1,800
c       read(41,'(f8.0,500e15.0)',end=403)
       read(41,*,end=403)
     #      tmin(itr),(etab0(itr,J),J=1,JEMON)
       write(6,'(2f10.2)')tmin(itr),etab0(itr,1)
       do j=1,jemon
          etab0(itr,j)=etab0(itr,j)-tide
       enddo
 402  continue
 403  continue
      iteta=itr-1
      close(41)
       write(6,*)'iteta=',iteta
C
       tmin(1)= 0.0
      do j=1,JEMON
        etab0(1      ,j) = etab0(2    ,j)
        etab0(iteta+1,j) = etab0(iteta,j)
      enddo
C
       tmin(iteta+1) =  99999.0
C
      return
      end
C
C##################################################################
c      subroutine shearcal(treal)
cC##################################################################
c      PARAMETER (MX=900,MY=900)
c      COMMON /PARA0/KMAX,IS,IE,JS,JE
c      COMMON /PARA1/DT,DX,DY
c      COMMON /TAUS0/itend,tmin(200),tsx0(200),tsy0(200)
c      COMMON /ETA0/ etab0(100)
c      COMMON /SHEAR/ TSX(MX,MY),TSY(MX,MY)
c      COMMON /TDP/ TD(MX,MY),TDX(MX,MY),TDY(MX,MY)
c      COMMON /BLCK3/ MAP(MX,MY)
c      COMMON /ETAB/ ETAB
cC
c      do itr=1,itend
c         if(treal.le.tmin(itr+1)) then
c           its=itr
c           goto 100
c         endif
c      enddo
cC
c  100 continue
cC
c      do i=3,IE+2
c      do j=3,JE+2
c         TSX(I,J)=tsx0(its)+(tsx0(its+1)-tsx0(its))
c     #                     *(treal-tmin(its))/(tmin(its+1)-tmin(its))
c         TSY(I,J)=tsy0(its)+(tsy0(its+1)-tsy0(its))
c     #                     *(treal-tmin(its))/(tmin(its+1)-tmin(its))
c      enddo
c      enddo
cC
c         ETAB=2.0*etab0(its)+2.0*(etab0(its+1)-etab0(its))
c     #                  *(treal-tmin(its))/(tmin(its+1)-tmin(its))
cC
c      do i=2,ie+4
c      do j=2,je+4
c       if(MAP(I,J).GE.1.OR.MAP(I-1,J).GE.1) then
c           TSX(I,J)=0.0
c       endif
c       if(MAP(I,J).GE.1.OR.MAP(I,J-1).GE.1) then
c           TSY(I,J)=0.0
c       endif
c      enddo
c      enddo
cC
cc      open(72,file='shearchk.dat')
cc          do i=3,ie+2
cc             write(72,'(200e12.2)')(tsx(i,j),j=3,je+2)
cc          enddo
cc      close(72)
Cc
c      return
c      end
cC
C##################################################################
      subroutine ebcal(treal)
C##################################################################
      PARAMETER (MX=900,MY=900)
      COMMON /PARA0/KMAX,IS,IE,JS,JE
      COMMON /PARA1/DT,DX,DY
      COMMON /ETA0/ JEMON,DYEMON,iteta, etab0(500,MY),tmin(500)
      COMMON /TDP/ TD(MX,MY),TDX(MX,MY),TDY(MX,MY)
      COMMON /BLCK3/ MAP(MX,MY)
      COMMON /ETAB/ ETAB(MY)
C
      do itr=1,iteta
         if(treal.le.tmin(itr+1)) then
           its=itr
           goto 100
         endif
      enddo
C
  100 continue
C
      do j=3,JE+2
         RRY=real(j-2)*DY/DYEMON
         JMS=min(JEMON,max(1,INT(RRY)))
         JME=min(JEMON,JMS+1)
         ETABL=2.0*etab0(its,JMS)+2.0*(etab0(its+1,JMS)-etab0(its,JMS))
     #                  *(treal-tmin(its))/(tmin(its+1)-tmin(its))
         ETABR=2.0*etab0(its,JME)+2.0*(etab0(its+1,JME)-etab0(its,JME))
     #                  *(treal-tmin(its))/(tmin(its+1)-tmin(its))
c
         if(RRY.LE.real(JMS)) then
           etab(j)=ETABL
         elseif(RRY.GE.real(JME)) then
           etab(j)=ETABR
         else
           etab(j)=ETABL+(ETABR-ETABL)*(RRY-REAL(JMS))
         endif
c
      enddo
C
C
C
c      open(72,file='shearchk.dat')
c          do i=3,ie+2
c             write(72,'(200e12.2)')(tsx(i,j),j=3,je+2)
c          enddo
c      close(72)
C
      return
      end
C
C##################################################################
      subroutine windpress(treal)
C##################################################################
      PARAMETER (MX=900,MY=900)
      COMMON /PARA0/KMAX,IS,IE,JS,JE
      COMMON /PARA1/DT,DX,DY
      COMMON /SHEAR/ TSX(MX,MY),TSY(MX,MY)
      COMMON /PRSUR/ PSR(MX,MY),DPDX(MX,MY),DPDY(MX,MY)
      COMMON /HURR/itend,tdt,tt(100),tx(100),ty(100),tp0(100),tr0(100)
      COMMON /TDP/ TD(MX,MY),TDX(MX,MY),TDY(MX,MY)
      COMMON /BLCK3/ MAP(MX,MY)
      COMMON /WIND/ WX(MX,MY),WY(MX,MY)
C
       pi=3.14159265
       pinf=1013.0
       roua=1.21
       alpha=pi/6.0
       el=500000.0
       C=0.7
       GAMMA=0.0026
       OMEGA=7.27E-5
C
      COL=2.0*OMEGA*sin(35.0*pi/180.0)
C
       itt=int(treal/tdt)+1
       frac=treal/tdt-real(itt-1)
       its=max(itt,1)
       ite=min(itt+1,itend)
c       write(6,*)'its=',its,'ite=',ite,'frac=',frac
c       if(itt.ge.itend) then
c          write(6,*)'itt is greater than itend!!!'
c          return
c       endif
        txk=frac* tx(ite)+(1.0-frac)* tx(its)
        tyk=frac* ty(ite)+(1.0-frac)* ty(its)
       tp0k=frac*tp0(ite)+(1.0-frac)*tp0(its)
       tr0k=frac*tr0(ite)+(1.0-frac)*tr0(its)
c
      vgrmx=0.0
       vtmx=0.0
C
      DO 10 I=1,IE+4
      DO 10 J=1,JE+4
         xx=DX*REAL(I-3)
         yy=DY*REAL(J-3)
c
       rr=sqrt((xx-txk)**2+(yy-tyk)**2)
c pressure in Pa, pinf and tp0k are in hPa
c pressure in Pa, pinf and tp0k are in hPa
       Psr(i,j)=-100.0*(pinf-tp0k)/sqrt(1.+(rr/tr0k)**2)
c
c gradient wind, remind tp0k in hPa
       vgr2=(pinf-tp0k)*100.0/(roua*tr0k*tr0k)
     #     *((1.0+(rr/tr0k)**2)**(-1.5))
       vgr=rr*(sqrt(col*col/4.0+vgr2)-col/2.0)
       vgrmx=amax1(vgrmx,vgr)
       if(abs(xx-txk).gt.1.0e-10.or.abs(yy-tyk).gt.1.0e-10) then
        theta=atan2(yy-tyk,xx-txk)
       else
        theta=pi/2.0
       end if
c
       vgx=-vgr*sin(theta-alpha)
       vgy= vgr*cos(theta-alpha)
c translation wind
       vtx0=(tx(itt+1)-tx(itt))/(tdt*60.0)
       vty0=(ty(itt+1)-ty(itt))/(tdt*60.0)
       vt=sqrt(vtx0**2+vty0**2)
       vtmx=amax1(vt,vtmx)
c
       vtx=vtx0*exp(-pi*rr/el)
       vty=vty0*exp(-pi*rr/el)
c
       wx(i,j)=C*(vgx+vtx)
       wy(i,j)=C*(vgy+vty)
c
       WABS=SQRT(WX(I,J)**2+WY(I,J)**2)
       wabsmx=amax1(wabs,wabsmx)
C
c wind stress on surface
       TSX(I,J)=ROUA*GAMMA*WABS*WX(I,J)
c     #            *0.5*(TANH((TDX(I,J)-2.5))+1)
       TSY(I,J)=ROUA*GAMMA*WABS*WY(I,J)
c     #            *0.5*(TANH((TDY(I,J)-2.5))+1)
c
c
c
 10   CONTINUE
c
      do i=2,ie+4
      do j=2,je+4
         DPDX(I,J)=(PSR(I,J)-PSR(I-1,J))/DX
c     #            *0.5*(TANH((TDX(I,J)-2.5))+1)
         DPDY(I,J)=(PSR(I,J)-PSR(I,J-1))/DY
c     #            *0.5*(TANH((TDY(I,J)-2.5))+1)
c
c
c       if(TDX(I,J).LE.5.0) then
       if(MAP(I,J).GE.1.OR.MAP(I-1,J).GE.1) then
           TSX(I,J)=0.0
          DPDX(I,J)=0.0
       endif
c       if(TDY(I,J).LE.5.0) then
       if(MAP(I,J).GE.1.OR.MAP(I,J-1).GE.1) then
           TSY(I,J)=0.0
          DPDY(I,J)=0.0
       endif
c
      enddo
      enddo
c
c
      RETURN
      END
cC
C##################################################################
      subroutine windSGW(treal)
C##################################################################
      PARAMETER (MX=900,MY=900)
      COMMON /PARA0/KMAX,IS,IE,JS,JE
      COMMON /PARA1/DT,DX,DY
      COMMON /SHEAR/ TSX(MX,MY),TSY(MX,MY)
      COMMON /PRSUR/ PSR(MX,MY),DPDX(MX,MY),DPDY(MX,MY)
      COMMON /HURR/itend,tdt,tt(100),tx(100),ty(100),tp0(100),tr0(100)
      COMMON /TDP/ TD(MX,MY),TDX(MX,MY),TDY(MX,MY)
      COMMON /BLCK3/ MAP(MX,MY)
      COMMON /WIND/ WX(MX,MY),WY(MX,MY)
C
C     Model based on Matoba et al(2006) Annual Proc. of Coastal Engineering(JSCE)
C
       pi=3.14159265
       pinf=1013.0
       ROUA=1.21
       alpha=pi/6.0
       el=500000.0
       CC=0.7
       GAMMA=0.0026*3
       OMEGA=7.27E-5
C
      COL=2.0*OMEGA*sin(35.0*pi/180.0)
C
       itt=int(treal/tdt)+1
       frac=treal/tdt-real(itt-1)
       its=max(itt,1)
       ite=min(itt+1,itend)
c       write(6,*)'its=',its,'ite=',ite,'frac=',frac
c       if(itt.ge.itend) then
c          write(6,*)'itt is greater than itend!!!'
c          return
c       endif
        txk=frac* tx(ite)+(1.0-frac)* tx(its)
        tyk=frac* ty(ite)+(1.0-frac)* ty(its)
       tp0k=frac*tp0(ite)+(1.0-frac)*tp0(its)
       tr0k=frac*tr0(ite)+(1.0-frac)*tr0(its)
c
      vgrmx=0.0
       vtmx=0.0
C
      DO 10 I=1,IE+4
      DO 10 J=1,JE+4
         xx=DX*REAL(I-3)
         yy=DY*REAL(J-3)
c
       rr=max(1.0,sqrt((xx-txk)**2+(yy-tyk)**2))
c pressure in hPa
       Psr(i,j)=(tp0k+(pinf-tp0k)*exp(-tr0k/rr))
       dp=(pinf-tp0k)
c
c gradient wind, remind tp0k in hPa
       vgr2=100.0*dp/roua/rr/rr/rr*tr0k*exp(-tr0k/rr)
       vgr=rr*(sqrt(col*col/4.0+vgr2)-col/2.0)
       vgrmx=amax1(vgrmx,vgr)
       if(abs(xx-txk).gt.1.0e-10.or.abs(yy-tyk).gt.1.0e-10) then
        theta=atan2(yy-tyk,xx-txk)
       else
        theta=pi/2.0
       end if
c
       vgx=-vgr*sin(theta-alpha)
       vgy= vgr*cos(theta-alpha)
c translation wind
       vtx0=(tx(itt+1)-tx(itt))/(tdt*60.0)
       vty0=(ty(itt+1)-ty(itt))/(tdt*60.0)
       vt=sqrt(vtx0**2+vty0**2)
       vtmx=amax1(vt,vtmx)
c
       vtx=vtx0*exp(-pi*rr/el)
       vty=vty0*exp(-pi*rr/el)
c
       C1inf = 2.0/3.0
       C1xp  = min(1.2, C1inf*(1.0+10.0**(0.0231*dp-1.96)))
       xp    = 0.5
       x     = rr/tr0k
c
       C1x   = C1inf+(C1xp-C1inf)*((x/xp)**1.5)
     #        *exp((1.0-1.0/2.5)*(1.0-(x/xp)**2.5))
c
       wx(i,j)=C1x*vgx+CC*vtx
       wy(i,j)=C1x*vgy+CC*vty
c
       WABS=SQRT(WX(I,J)**2+WY(I,J)**2)
       wabsmx=amax1(wabs,wabsmx)
C
c wind stress on surface
       if(WABS.LE.8.0) then
         CD=0.0011*(1.290-0.024*WABS)
       else
         CD=0.0011*(0.581+0.063*WABS)
       endif
c
       TSX(I,J)=ROUA*CD*WABS*WX(I,J)
       TSY(I,J)=ROUA*CD*WABS*WY(I,J)
c
c
c
 10   CONTINUE
c
      do i=2,ie+4
      do j=2,je+4
         DPDX(I,J)=100.0*(PSR(I,J)-PSR(I-1,J))/DX
         DPDY(I,J)=100.0*(PSR(I,J)-PSR(I,J-1))/DY
c
c
Check
cc       if(TDX(I,J).LE.5.0) then
       if(MAP(I,J).GE.1.OR.MAP(I-1,J).GE.1) then
           TSX(I,J)=0.0
          DPDX(I,J)=0.0
       endif
c       if(TDY(I,J).LE.5.0) then
       if(MAP(I,J).GE.1.OR.MAP(I,J-1).GE.1) then
           TSY(I,J)=0.0
          DPDY(I,J)=0.0
       endif
Check
c
      enddo
      enddo
c
c
      RETURN
      END
cC
C
C
c######################################################################
      subroutine position
c######################################################################
      PARAMETER (MX=900,MY=900)
      COMMON /posit/ xxx(mx,my),yyy(mx,my)
      COMMON /PARA0/KMAX,IS,IE,JS,JE
      COMMON /PARA1/DT,DX,DY
C
      Xmin=-55949.0819
      Xmax=-25999.0819
C
      Ymin= -8932.9314
      Ymax=  6017.0686
C
C
      do i=IS+2,IE+2
      do j=JS+2,JE+2
         xxx(i,j)=Xmax+(Xmin-Xmax)*(real(i-is-2))/real(IE-IS)
         yyy(i,j)=Ymin+(Ymax-Ymin)*(real(j-js-2))/real(jE-jS)
      enddo
      enddo
c
      return
      end
C
c
c
cc######################################################################
c      subroutine position
cc######################################################################
c      PARAMETER (MX=900,MY=900)
c      COMMON /posit/ xxx(mx,my),yyy(mx,my)
cC
c      ncols=720
c      nrows=660
c      xllcorner=-25707.017161883
c      yllcorner=-52856.110171295
c      cellsize=50.
cc
c      is=179
c      ie=473
c      js=364
c      je=580
cc
c      ii = ie-is+1
c      jj = je-js+1
c      pi = 3.14159265
cc
c      do i=1,ii
c      do j=1,jj
c         xxx(i+2,j+2)=xllcorner+real(js+j-2)*cellsize
c         yyy(i+2,j+2)=yllcorner+real(nrows-is-i+1)*cellsize
c      enddo
c      enddo
cc
c      return
c      end
cC
c
c
